<?php 

defined('_JEXEC') or die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

/**
 *
 *  Virtuemart PayPal Plus SSC
 *  Online Store Copyright 2019
 *  This code is copyright of online-store.co.uk
 *  You are not allowed to distribute or sell this code.
 *  http://plugins.online-store.co.uk/
*/


if (!class_exists('VmConfig'))
	require(JPATH_ADMINISTRATOR . '/' . 'components' . '/' . 'com_virtuemart' . '/' . 'helpers' . '/' . 'config.php');
 
if (!class_exists('vmPSPlugin'))
    require(JPATH_VM_PLUGINS . '/' . 'vmpsplugin.php');
    

use PayPal\Api\Payment;
    

class plgVmPaymentPaypalplusssc extends vmPSPlugin
	{
        public static $_this = false;
    private $_rest = true;

    function __construct(& $subject, $config) {
			parent::__construct($subject, $config);
	
	$this->_loggable = false;
	$this->tableFields = array_keys($this->getTableSQLFields());
	$this->_tablepkey = 'id';
	$this->_tableId = 'id';

	
	$varsToPush = array(

     "ssc_api_username" => array('', 'char'),
     "ssc_api_password" => array('', 'char'),
     "ssc_api_signature" => array('', 'char'),
     "ssc_environment" => array('', 'char'),
     "ssc_api_sb_username" => array('', 'char'),
     "ssc_api_sb_password" => array('', 'char'),
     "ssc_api_sb_signature" => array('', 'char'),
     "ssc_payment_action" => array('Sale', 'char'),
     "ssc_user_action" => array('', 'char'),
     "ssc_multi_currency" => array(0, 'int'),
     "ssc_one_page" => array(1, 'int'),
     "ssc_third_party_payments" => array(1, 'int'),
     
	 "payment_currency" => array('', 'int'),
	 	 "sandbox" => array(0, 'int'),
	 
	 "ssc_address_required" => array(2, 'int'),
	 "ssc_address_override" => array(1, 'int'),
	  
	 "payment_logos" => array('', 'char'),
	 "debug" => array(0, 'int'),
	 "status_pending" => array('', 'char'),
	 "status_success" => array('', 'char'),
	 "status_canceled" => array('', 'char'),
	 
	"status_partial_refunded" => array('R', 'char'),
	"status_refunded" => array('R', 'char'),
	"status_denied" => array('D', 'char'),

	 "countries" => array('', 'char'),
	 "min_amount" => array('', 'int'),
	 "max_amount" => array('', 'int'),
		
	"categories" => array('', 'char'),
	"blocking_categories" => array('', 'char'),

		"cost_per_transaction" => array(0, 'float'),
		 "cost_percent_total" => array(0, 'float'),
	 "countries" => array('', 'char'),
	 "tax_id" => array(-1, 'int'),
	 "ssc_landing_page" => array('', 'char'),
	 "ssc_solution_type" => array('', 'char'),
	 "ssc_ssc1" => array('', 'char'),
	 "ssc_ssc2" => array('', 'char'),

	"ssc_HDRIMG" => array('', 'char'),
	"ssc_PAYFLOWCOLOR" => array('', 'char'),
	"ssc_BRANDNAME" => array('', 'char'),
	"ssc_show_thank_you" => array(1, 'int'),
	"ssc_show_receipt_address" => array(1, 'int'),
	"ssc_payment_header" => array('', 'char'),
	"ssc_payment_footer" => array('', 'char'),
	"ssc_receipt_header" => array('', 'char'),
	"ssc_receipt_footer" => array('', 'char'),
	"ssc_raw" => array('', 'char'),
	"ssc_short_cut_cart" => array('', 'char'),
	"ssc_ipn_updates" => array(0, 'int')
	);



	$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);

	    }

    public function getVmPluginCreateTableSQL() {

	return $this->createTableSQL('PayPal Payments Pro Table');
    }

    function getTableSQLFields() {


$SQLfields = array(
	    "id" => 'int(1) unsigned NOT NULL AUTO_INCREMENT',
	    "virtuemart_order_id" => 'int(1) UNSIGNED',
	    "order_number" => 'char(32)',
	    "virtuemart_paymentmethod_id" => 'mediumint(1) UNSIGNED',
	    "payment_name" => 'char(255) NOT NULL DEFAULT \'\'',
	    "payment_order_total" => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\'',
	    "payment_currency" => 'char(3)',
	    "currency_code" => 'varchar(3)',
	    	       	    "cost_per_transaction" => 'decimal(10,2)',
	    "cost_percent_total" => 'decimal(10,2)',
	    "tax_id" => 'smallint(1)',
	    "paypal_custom" => 'varchar(255)',

       "paypal_response_payment_status" => 'char(50)',
	    "paypalresponse_raw" => 'varchar(512)',
	    "alt_currency" => 'char(3)',
	    "paypal_fullresponse" => "text"
	);


$db = JFactory::getDBO();

if($this->table_exist('virtuemart_payment_plg_paypalplusssc',0))

{

try
	{
	$columns = $db->getTableColumns('#__virtuemart_payment_plg_paypalplusssc');
	if(!isset($columns['paypal_fullresponse']))
		{
		$q = 'ALTER TABLE `#__virtuemart_payment_plg_paypalplusssc` ADD COLUMN `paypal_fullresponse` text AFTER `paypalresponse_raw`';
		$db->setQuery($q);
		$db->query($q);
						}
		
	if(!isset($columns['alt_currency']))
		{
		$q = 'ALTER TABLE `#__virtuemart_payment_plg_paypalplusssc` ADD COLUMN `alt_currency` char(3) AFTER `paypalresponse_raw`';
		$db->setQuery($q);
		$db->query($q);
						}
	
		
	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}
}

$ssc = $this->ssc_check();

$document = JFactory::getDocument();
$document->addScript('https://www.paypalobjects.com/webstatic/ppplus/ppplus.min.js');

	return $SQLfields;
    }




function plgVmConfirmedOrder($cart, $order)
{


$db = JFactory::getDbo();



$jinput =JFactory::getApplication()->input;
	 
$param_get['ecoplus'] = $jinput->get->get('ecoplus', null, 'CMD');


$eco=0;

if (isset($param_get['ecoplus']))
	{
	$eco=1;
	$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalplusssc" AND `published` = 1';
	$db->setQuery($q);
	$virtuemart_paymentmethod_id = $db->loadResult();
	$method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);
	}
else
	{
	if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id)))
		{
		return null; 		}
	}	
	
if (!$this->selectedThisElement($method->payment_element))
	{
	return false;
	}
	
	
	$html='';
	$state='';
	$country='';
	$session = JFactory::getSession();
	$return_context = $session->getId();
	$this->_debug = $method->debug;
	
	if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
	if (!class_exists('VirtueMartModelCurrency'))
	    require(JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'currency.php');

	$new_status = '';

	$address = $order['details']['BT'];
	$del_address = null;
	
	if(isset($order['details']['ST']))
	   {
	   $del_address = $order['details']['ST'];
	   }
	else
	   {
	   $del_address = $order['details']['BT'];
	   }


if($eco == 0)
	{
	if(method_exists($this,'setInConfirmOrder'))
		{
				}
			
   if (!class_exists('TableVendors'))
	    require(JPATH_VM_ADMINISTRATOR . '/' . 'table' . '/' . 'vendors.php');
	$vendorModel = new VirtueMartModelVendor();
	$vendorModel->setId(1);
	$vendor = $vendorModel->getVendor();
	$vendorModel->addImages($vendor, 1);
	
	
	$extension_id='17';	
	
	try
	{	 
	$db = JFactory::getDBO();
	$query =
	"SELECT " . $db->quoteName('virtuemart_userfield_id') .
	" FROM " . $db->quoteName('#__virtuemart_userfields') .
	" WHERE " . $db->quoteName('name') ." = " . $db->quote('virtuemart_state_id').";";
	$db->setQuery($query);
	$extension_id = $db->loadResult();
	}
	catch (Exception $e)
		{
						    			}

	try
	{
	$db = JFactory::getDBO();
	$query = $db->getQuery(true);
	$fields = array($db->quoteName('required') . '=1');
		$conditions = array($db->quoteName('virtuemart_userfield_id') . '=' . $extension_id);  	$query->update($db->quoteName('#__virtuemart_userfields'))->set($fields)->where($conditions);
	$db->setQuery($query);
	$result = $db->query();
	}
	catch (Exception $e)
		{
						    			}
	
	
	}



	$this->getPaymentCurrency($method); 
	
	$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
	$db = JFactory::getDBO();
	$db->setQuery($q);
	$currency_code_3 = $db->loadResult();


   $q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
	
	$db->setQuery($q);
	$currency_symbol = $db->loadResult();
	
	
	$processor_currency_code_3 = $currency_code_3;
	
		
	if($method->ssc_multi_currency)
		{
		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $cart->pricesCurrency . '" ';
		
		$db->setQuery($q);
		$processor_currency_code_3 = $db->loadResult();
		}

	$dp=2;
	
	if($processor_currency_code_3 == 'JPY')
		{
		$dp=0;
		}

	if (!class_exists('CurrencyDisplay'))
   require(JPATH_VM_ADMINISTRATOR . '/' . 'helpers' . '/' . 'currencydisplay.php');


	$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
	$cd = CurrencyDisplay::getInstance($cart->pricesCurrency);
	
	if($eco == 0)
	{
	$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total,false), $dp);
		$dbValues["order_number"] = $order["details"]["BT"]->order_number;
	$dbValues["payment_name"] = $this->renderPluginName($method, $order);
	$dbValues["virtuemart_paymentmethod_id"] = $cart->virtuemart_paymentmethod_id;
	$dbValues["paypal_custom"] = $return_context;
	$dbValues["cost_per_transaction"] = $method->cost_per_transaction;
	$dbValues["cost_percent_total"] = $method->cost_percent_total;
	
	$dbValues["payment_currency"] = $method->payment_currency;
	
		
	$dbValues["currency_code"] = $currency_code_3;
	
		
	if($method->ssc_multi_currency)
		{
		$dbValues["alt_currency"] = $cart->pricesCurrency;
		}
	else
		{
		$dbValues["alt_currency"] = $method->payment_currency;
		}
	
	$dbValues["payment_order_total"] = $totalInPaymentCurrency;
	$dbValues['tax_id'] = $method->tax_id;
	$this->storePSPluginInternalData($dbValues);
	}

$invoice_num='';

if($eco == 0)
	{
	if(isset($order["details"]["BT"]->order_number))
		{
		$invoice_num = $order["details"]["BT"]->order_number;
		}
	
	$session = JFactory::getSession();
	
	$session_token = $session->get('session_token');
	$session_PayerID = $session->get('session_PayerID');

	if(is_null($session->get('session_token')))
		{
				}
	else
		{
			
		$ret = $this->doexpress($session_token,$session_PayerID,$invoice_num);
	
		$session->set('session_token', null);
		$session->set('session_PayerID', null);
		$session->set('session_ssc_total', null);

		return $ret;	
		}

	}

$description 	= "";
$label 			= "Submit Payment"; 

$loginID = "";

$product_des = "";
$short_product_des = "";

$order_form_line_item='';
$br = "\n";	

$currency_type = '0';

	$currency_type = $cart->pricesCurrency;

$pppitems = array();

if($order)
	{
	list($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems) = $this->order_form($order,$method,$currency_type);
	}
else
	{
	list($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems) = $this->order_form_cart($order,$method,$currency_type);
	}

$country = '';
$cc_state = '';
$del_country = '';
$del_state = '';
$del_state_name = '';
$cc_country='';

if($eco == 0)
{
	
$country = ShopFunctions::getCountryByID($address->virtuemart_country_id, "country_2_code");
$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";


if($country === 'US' || $del_country === 'CA')
  {
  $cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id,"state_2_code") : "";
  }


$del_country = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, "country_2_code");
$del_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id) : "";
$del_state_name = $del_state;
if($del_country === 'US' || $del_country === 'CA')
  {
  $del_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id,"state_2_code") : "";
  }



$pro_shipping = urlencode("Overland");

$cc_country = ShopFunctions::getCountryByID($address->virtuemart_country_id, "country_2_code");


	
$del_country = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, "country_2_code");
}



if($eco == 0)
	{
	$ReturnURL = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&e=0');
	$CancelURL = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel&on=' . urlencode($order['details']['BT']->order_number) . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id);
	}
else
	{
	$ReturnURL = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&e=1');
	$CancelURL = $this->https_check(JURI::root() . 'index.php');
	}

$IPN =  $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component');


$landingpage = '';
$solutiontype = '';

if($method->ssc_landing_page === 'Billing')
	{
	$landingpage = '&LANDINGPAGE=Billing';
	}

if($method->ssc_landing_page === 'Login')
	{
	$landingpage = '&LANDINGPAGE=Login';
	}


if($method->ssc_solution_type === 'Sole' || $method->ssc_solution_type === '')
	{
	$solutiontype = '&SOLUTIONTYPE=Sole';
	}
	
if($method->ssc_solution_type === 'Mark')
	{
	$solutiontype = '&SOLUTIONTYPE=Mark';
	}


$ssc_HDRIMG = trim($method->ssc_HDRIMG);
if(!($ssc_HDRIMG === ''))
	{
	if (preg_match("/^https:\/\//i", $ssc_HDRIMG))
		{
		$ssc_HDRIMG = '&HDRIMG=' . urlencode($ssc_HDRIMG);
		}
	else
		{
		$ssc_HDRIMG = '';
		}
	
	}



$ssc_PAYFLOWCOLOR = trim($method->ssc_PAYFLOWCOLOR);

if(!($ssc_PAYFLOWCOLOR === ''))
	{
	$ssc_PAYFLOWCOLOR = preg_replace("/[^A-Za-z0-9]/", "", $ssc_PAYFLOWCOLOR);
	
	$ssc_PAYFLOWCOLOR = '&CARTBORDERCOLOR=' . urlencode($ssc_PAYFLOWCOLOR);
	}
	

$ssc_BRANDNAME = trim($method->ssc_BRANDNAME);
if(!($ssc_BRANDNAME === ''))
	{
	$ssc_BRANDNAME = '&BRANDNAME=' . urlencode($ssc_BRANDNAME);
	}



$hidessc = "<style>
img#hidessc + h1
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + h3
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + div > h3:first-child
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<img id='hidessc'/>
";


if($this->_rest == true)
{

$ssc1 = $method->ssc_ssc1;
$ssc2 = $method->ssc_ssc2;

$apiContext = new \PayPal\Rest\ApiContext
	(
	new \PayPal\Auth\OAuthTokenCredential(
	$ssc1,
	$ssc2
	)
);




$m = "LIVE";

if($method->ssc_environment == "sandbox")
   {
   $m = "SANDBOX";
   }


$apiContext->setConfig(
    array('mode' => $m)
); 




$payer = new \PayPal\Api\Payer();
$payer->setPaymentMethod("paypal");


$payerinfo = new \PayPal\Api\PayerInfo();
$payerinfo->setEmail($address->email);
$payerinfo->setFirstName($address->first_name);
$payerinfo->setLastName($address->last_name);


$billing_address = new \PayPal\Api\Address();
$billing_address->setLine1($address->address_1);
$billing_address->setLine2($address->address_2);
$billing_address->setCity($address->city);
$billing_address->setPostalCode($address->zip);
$billing_address->setState($cc_state);
$billing_address->setCountryCode($cc_country);
$payerinfo->setBillingAddress($billing_address);

$payer->setPayerInfo($payerinfo);




$itemList = new \PayPal\Api\ItemList();


$itemList->setItems($pppitems);

$shipping_address = new \PayPal\Api\ShippingAddress();
$shipping_address->setRecipientName($del_address->first_name . ' ' . $del_address->last_name);
$shipping_address->setLine1($del_address->address_1);
$shipping_address->setLine2($del_address->address_2);
$shipping_address->setCity($del_address->city);
$shipping_address->setPostalCode($del_address->zip);
$shipping_address->setState($del_state);
$shipping_address->setCountryCode($del_country);
$itemList->setShippingAddress($shipping_address);


$details = new \PayPal\Api\Details();
$details->setShipping($shipping)
	->setTax($total_tax)
	->setSubtotal($line_order_total);


$amount = new \PayPal\Api\Amount();
$amount->setCurrency($processor_currency_code_3)
	->setTotal($order_total)
	->setDetails($details);
    

$uniqid = $invoice_num;

$transaction = new \PayPal\Api\Transaction();
$transaction->setAmount($amount)
	->setItemList($itemList)
	->setDescription("Payment description")
	->setInvoiceNumber($uniqid);

if($method->ssc_ipn_updates == 1)
	{
	$transaction->setNotifyUrl($IPN);	
	}

$ReturnURL .= '&pectransid=' . urlencode($invoice_num) . '&api=rest';
$CancelURL .= '&api=rest';

$redirectUrls = new \PayPal\Api\RedirectUrls();
$redirectUrls->setReturnUrl($ReturnURL)
    ->setCancelUrl($CancelURL);

$payment = new \PayPal\Api\Payment();
$payment->setIntent("sale")
    ->setPayer($payer)
    ->setRedirectUrls($redirectUrls)
    ->setTransactions(array($transaction));
    
try{
	$payment->create($apiContext);
	}
catch
	(Exception $ex)
	{
	
						
	$error_html = JText::_('VMPAYMENT_PPP_SSC_TRY_AGAIN') . '<br/>';
	
	        	
	$error_html .= '<br>' . JText::_('VMPAYMENT_PPP_SSC_CHECK_MISSPELLINGS') . '<br/>';
	
	
	$html .= $error_html;
	
	$html .= "<script language='JavaScript'><!--\r\n" .
   "document.write('<input type=\"button\" value=\"Zur&uuml;ck\" name=\"b1\" onClick=\"history.go(-1)\">&nbsp;&nbsp;')" .           
   "\r\n--></script>";
   
			
	if($method->debug)
		{
        $html .= $ex;
        }
		
	$this->redirectToCart($error_html);
	 	
		
	$opc_enabled = 0;

        $opc_enabled = $this->opc_enabled();

        if($opc_enabled == '1')
            {
                        echo $html;
            $html='';
            }



	echo $hidessc;
	        return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $new_status);
	}


$link = $payment->getApprovalLink();





	





if($country == '')
	{
	$country = "DE";
	}
	
	
$m = "live";

if($method->ssc_environment == "sandbox")
   {
   $m = "sandbox";
   }


$lang = JFactory::getLanguage();
$languages = JLanguageHelper::getLanguages("lang_code");
$tag = $lang->getTag();


if($country == "US")
	{
	$tag = "en_US";
	}




$tag = strtr($tag,'-','_');

$rest = 0;
if($rest == 1)
{

$html .= "
<div id='ssc' style='visibility: hidden'>
</div>

<script type='application/javascript'>
var ppp = PAYPAL.apps.PPP({
'approvalUrl': '" . $link . "',
'placeholder': 'ssc',
'mode': '" . $m . "',
'country': '" . $country . "',
'language' : '" . $tag . "',
'buttonLocation': 'outside',
'useraction' : 'commit',
'showLoadingIndicator': true,
'showPuiOnSandbox': true,
'enableContinue': 'continueButton',
onLoad: function () {upload();},

});



function upload()
	{
	if ( typeof PAYPAL != 'undefined' )
		{
		PAYPAL.apps.PPP.doCheckout();
		}
	else
		{
		setTimeout(
			function()
			{
			PAYPAL.apps.PPP.doCheckout();
			}, 3000 );
		}
	}

</script><br/>";

$html .= ' <button
style="background:#0000ff;color:#ffffff;border-style: solid;border-color:#0000ff;border-width:6x;border-radius:16px;font-weight:normal;font-size: large;cursor:pointer"
type="submit"
id="continueButton"
onclick="PAYPAL.apps.PPP.doCheckout();">
' . JText::_('VMPAYMENT_PPP_SSC_CONTINUE') . '
</button><br/><br/><br/>';


}
else
{

$html .= "
<div id='ssc'>
</div>

<script type='application/javascript'>
var ppp = PAYPAL.apps.PPP({
'approvalUrl': '" . $link . "',
'placeholder': 'ssc',
'mode': '" . $m . "',
'country': '" . $country . "',
'language' : '" . $tag . "',
'buttonLocation': 'inside',
'useraction' : 'commit',
'showLoadingIndicator': true,
'showPuiOnSandbox': true,
'enableContinue': 'continueButton',

});

</script><br/><br/><br/><br/>";
}



$html .= "<input type='hidden' name='$uniqid' value='$uniqid'>";

	        
$opc_enabled = 0;

$opc_enabled = $this->opc_enabled();

if($opc_enabled == '1')
    {
        echo $html;
    $html='';
    }
    

echo $hidessc;


	return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $new_status);




}




$APIrequest =
"&PAYMENTREQUEST_0_PAYMENTACTION=" . $method->ssc_payment_action .

"&RETURNURL=". urlencode($ReturnURL) . urlencode('&pectransid=' . $invoice_num) .

"&CANCELURL=". urlencode($CancelURL);


if($eco == 0)
	{
	$APIrequest .=
	"&PAYMENTREQUEST_0_INVNUM=" . urlencode($invoice_num);
	}
	
$APIrequest .=
"&LOCALECODE=" . $cc_country .

"&PAYMENTREQUEST_0_CURRENCYCODE=" . $processor_currency_code_3 .
"&PAYMENTREQUEST_0_ITEMAMT=" . $line_order_total .
"&PAYMENTREQUEST_0_SHIPPINGAMT=" . $shipping .
"&PAYMENTREQUEST_0_TAXAMT=" . $total_tax .
"&PAYMENTREQUEST_0_AMT=" . $order_total;

if($eco == 0)
	{
	$APIrequest .=
	"&PAYMENTREQUEST_0_SHIPTONAME=" . urlencode($del_address->first_name . ' ' . $del_address->last_name) .
	"&PAYMENTREQUEST_0_SHIPTOSTREET=" . urlencode($del_address->address_1) .
	"&PAYMENTREQUEST_0_SHIPTOSTREET2=" . urlencode($del_address->address_2) .
	"&PAYMENTREQUEST_0_SHIPTOSTATE=" . urlencode($del_state) . 
	"&PAYMENTREQUEST_0_SHIPTOCITY=" . urlencode($del_address->city) . 
	"&PAYMENTREQUEST_0_SHIPTOZIP=" . urlencode($del_address->zip) .
	"&PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE=" . urlencode($del_country) .
	"&PAYMENTREQUEST_0_SHIPTOPHONENUM=" . urlencode($address->phone_1) .
	"&ADDROVERRIDE=" . '1' .
		"&EMAIL=" . urlencode($address->email);
	}



$bt=0;
$st=0;

if($eco == 1)
	{

		
		if(isset($cart->BT['last_name']))
		{
		$bt=1;
		
		if(isset($cart->STsameAsBT) && $cart->STsameAsBT == 0)
			{
			$st=1;
			}	
			
		}
				
	$cart_address = null;
	
	if($bt==1 && $st==0)
	   {
	   $cart_address = $cart->BT;
	   }
	   
	if($bt==1 && $st==1)
		{
	   		$cart_address = $cart->getST();
	   }

	
	
		$cart_state = '';

	if(!is_null($cart_address))
		{
  		$cart_country = '';
		$cart_state = '';

		$cart_country = ShopFunctions::getCountryByID($cart_address['virtuemart_country_id'], "country_2_code");
		$cart_state = isset($cart_address['virtuemart_state_id']) ? ShopFunctions::getStateByID($cart_address['virtuemart_state_id']) : "";

		if($cart_country === 'US' || $cart_country === 'CA')
		  {
		  $cart_state = isset($cart_address['virtuemart_state_id']) ? ShopFunctions::getStateByID($cart_address['virtuemart_state_id'],"state_2_code") : "";
		  }

		$output =
		"&PAYMENTREQUEST_0_SHIPTONAME=" . urlencode($cart_address['first_name'] . ' ' . $cart_address['last_name']) .
		"&PAYMENTREQUEST_0_SHIPTOSTREET=" . urlencode($cart_address['address_1']) .
		"&PAYMENTREQUEST_0_SHIPTOSTREET2=" . urlencode($cart_address['address_2']) .
		"&PAYMENTREQUEST_0_SHIPTOSTATE=" . urlencode($cart_state) . 
		"&PAYMENTREQUEST_0_SHIPTOCITY=" . urlencode($cart_address['city']) . 
		"&PAYMENTREQUEST_0_SHIPTOZIP=" . urlencode($cart_address['zip']) .
		"&PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE=" . urlencode($cart_country) .
		"&PAYMENTREQUEST_0_SHIPTOPHONENUM=" . urlencode($cart->BT['phone_1']) .
		"&ADDROVERRIDE=" . '1' .
				"&EMAIL=" . urlencode($cart->BT['email']);
		
				
		$APIrequest .= $output;
		
		}
	}

	

$APIrequest .=
$landingpage .

$solutiontype .

"&NOSHIPPING=" . $method->ssc_address_required .

$line_order_details .


"&PAYMENTREQUEST_0_NOTIFYURL=" . urlencode($IPN) .


$ssc_HDRIMG .
$ssc_PAYFLOWCOLOR .
$ssc_BRANDNAME;

if($method->debug)
	{
	$html .= 'contacting paypal server<br>';
	$html .= $APIrequest;
	
	
	}




$httpResponse = $this->PPHttpPost($method,"SetExpressCheckout", $APIrequest);

if($method->debug)
	{
	$html .= '<br>contact complete<br>';
	}



if("SUCCESS" == strtoupper($httpResponse["ACK"]) || "SUCCESSWITHWARNING" == strtoupper($httpResponse["ACK"]))
   {

   
   $html .= "<p style='font-size: x-large'>" . JText::_('VMPAYMENT_PPP_SSC_CONNECTING_TO_PAYPAL') . "</p>";
   
   $token = urldecode($httpResponse["TOKEN"]);
   

$d = 0;

$paypal_url ="";

if($method->ssc_environment === "sandbox" || $d==1)
   {
   $paypal_url = "sandbox.paypal.com";
   }
else
   {
   $paypal_url = "paypal.com";
   }




if($method->ssc_user_action === "commit" && $eco == 0)
	{
	$paypal_url = "https://www.$paypal_url/cgi-bin/webscr?cmd=_express-checkout&useraction=commit&token=$token";
	}
else
	{
	$paypal_url =   "https://www.$paypal_url/cgi-bin/webscr?cmd=_express-checkout&token=$token";
	}

$html .= "<form name='postform' action='" . $paypal_url . "' method ='post'>";                                         
$html .= '<input type="hidden" name="b1" value="a">';
$html .= '<input type="submit" name="submit_button" value="' . JText::_('VMPAYMENT_PPP_SSC_CLICK') . '"><br><br>';
$html .= '</form>';
   

if(!$method->debug && $d==0)
   {
   $html .= '<script type="text/javascript">';
   $html .= 'document.postform.submit();';
   $html .= '</script>';
   }



if($eco == 1)
	{
	echo $html;
		$html = '';
	}



print "<style>
img#hidessc + h1
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>";

print "<style>
img#hidessc + h3
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>

<style>
img#hidessc + div > h3:first-child
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>

<img id='hidessc'/>
";

		
	return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $new_status);

   }
else
   {
   $order_form_city = JText::_('VMPAYMENT_PPP_SSC_CITY');
	$order_form_state = JText::_('VMPAYMENT_PPP_SSC_STATE');
	$order_form_country = JText::_('VMPAYMENT_PPP_SSC_COUNTRY');
	$order_form_zip = JText::_('VMPAYMENT_PPP_SSC_ZIP');


   $return_button = "<script language='JavaScript'><!--\r\n" .
   "document.write('<br><br><input type=\"button\" value=\"Return\" name=\"b1\" onClick=\"history.go(-1)\">&nbsp;&nbsp;')" .           
   "\r\n--></script>";   
   
   $s=0;
   $error ="No";
         $html .= "<span style='font-family: Arial, Helvetica, sans-serif; font-size: large; color: #FF0000'>";
   while(isset($httpResponse["L_LONGMESSAGE" . $s]))
   {

   
   if($httpResponse["L_ERRORCODE" . $s] == "500")
      {
	  $html .= JText::_('VMPAYMENT_PPP_SSC_UNKNOWN_ERROR');   
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "81234")
      {
      $html .= "";        
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10002" && $httpResponse["L_LONGMESSAGE" . $s] == 'Security%20header%20is%20not%20valid')
      {
      $html .= "Please check your API Username, Password and Signature for your Live or Sandbox account.";	         
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10002" && $httpResponse["L_LONGMESSAGE" . $s] == 'You%20do%20not%20have%20permissions%20to%20make%20this%20API%20call')
      {
      $html .= "Do you have a valid PayPal Live or Sandbox account with the correct API Username, Password and Signature";	         
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10736")
      {
      $html .= JText::_('VMPAYMENT_PPP_SSC_SHIPPING_ADDRESS_ERROR') . "<br><br>";
      
    if($eco == 1)    
      {  
		$cart_state = isset($cart_address['virtuemart_state_id']) ? ShopFunctions::getStateByID($cart_address['virtuemart_state_id']) : "";      
      $html .= $order_form_city .': ' . $cart_address['city'] . "<br>";
      $html .= $order_form_zip . ': ' . $cart_address['zip'] . "<br>";
      $html .= $order_form_state . ': ' . $cart_state . "<br><br>"; 
		}
	else
		{
		$cart_state = isset($cart_address['virtuemart_state_id']) ? ShopFunctions::getStateByID($del_address['virtuemart_state_id']) : "";      
	    $html .= $order_form_city .': ' . $del_address->city . "<br>";
      $html .= $order_form_zip . ': ' . $del_address->zip . "<br>";
      $html .= $order_form_state . ': ' . $del_state_name. "<br><br>";  
		} 

      $html .= JText::_('VMPAYMENT_PPP_SSC_CHECK_MISSPELLINGS') . "<br><br>";
      
    if(($bt==1 && $st==1) || isset($order['details']['ST']))
	   {
	   $html .= '<a href="' . $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=ST">Edit Address</a></strong>';
	   }
	else
	   {
	    $html .= '<a href="' . $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=BT">Edit Address</a></strong>';
	   }

      }
      
   	elseif($httpResponse["L_ERRORCODE" . $s] == "10729")
       {
       $html .= "Your Address do not include a State. Please add a State.<br><br>";	
      
       if(($bt==1 && $st==1) || isset($order['details']['ST']))
          {
	      $html .= '<a href="' . $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=ST">Edit Address</a></strong>';
	      }   
	   else
	      {
	      $html .= '<a href="' . $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=BT">Edit Address</a></strong>';
	      }
      }
  
  	elseif($httpResponse["L_ERRORCODE" . $s] == "10730")
       {
       $html .=  "Your Address do not include a Zip Code. Please add a Zip Code.<br><br>";	
      
       if(($bt==1 && $st==1) || isset($order['details']['ST']))
          {
	      $html .= '<a href="' . $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=ST">Edit Address</a></strong>';
	      }   
	   else
	      {
	      $html .= '<a href="' . $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=BT">Edit Address</a></strong>';
	      }
      }

   
  
   else
      {
   
      if($error == 'No')
         {      
         $html .=  "<br>" . JText::_('VMPAYMENT_PPP_SSC_TRY_AGAIN') . "<br>";
         $error='Yes';
         }
         	         
      $html .= $httpResponse["L_ERRORCODE" . $s] . ": " . urldecode($httpResponse["L_LONGMESSAGE" . $s]) . " <br><br>\r\n";  
      }
   $s++;
     
   }
    $html .= $return_button;
    $html .= "<br></span><br>";
}









if($eco == 1)
	{
	echo $html;
		$html = '';
	}
		


    
$hidessc = "<style>
img#hidessc + h1
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + h3
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + div > h3:first-child
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<img id='hidessc'/>
";

echo $hidessc;



	return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $new_status);


}



function redirectToCart ($msg = NULL)
	{
	if($msg != NULL)
		{
		$session = JFactory::getSession();
		$session->set('ssc_message', $msg);
		}
	else
		{
		$session = JFactory::getSession();
		$session->set('ssc_message', '');
		}

	if (!$msg)
		{
		$msg = vmText::_('VMPAYMENT_PAYPAL_ERROR_TRY_AGAIN');
		}
			
			
	
				$app = JFactory::getApplication();
	$app->enqueueMessage($msg,JText::_('VMPAYMENT_PPP_SSC_ERROR_CONNECTING_TO_SERVER'));
		$app->redirect(JRoute::_('index.php?option=com_virtuemart&view=cart', false));
	
	}






function opc_enabled()
	{
	$opc = 0;
	$vp_opc = 0;
	$opc_enabled = 0;

						
	$db = JFactory::getDbo();
			
	if($opc_enabled != '1')
		{
		$db->setQuery("SELECT `enabled` FROM `#__extensions` WHERE `name` = 'VP One Page Checkout'");
		$opc_enabled = $db->loadResult();
		$vp_opc = $opc_enabled;
		}

	if($opc_enabled != '1')
		{
		$db->setQuery("SELECT `enabled` FROM `#__extensions` WHERE `name` = 'System - VP One Page Checkout'");
		$opc_enabled = $db->loadResult();
		$vp_opc = $opc_enabled;
		}

	return $opc_enabled;
	}

        
        



function handlePaymentUserCancel ($virtuemart_order_id)
	{
	if ($virtuemart_order_id)
		{
				if (!class_exists ('VirtueMartModelOrders'))
			{
			require(VMPATH_ADMIN . '/' . 'models' . '/' . 'orders.php');
			}

		$modelOrder = VmModel::getModel ('orders');
		$order['order_status'] = 'X';
		$order['virtuemart_order_id'] = $virtuemart_order_id;
		$order['customer_notified'] = 0;
		$order['comments'] = vmText::_ ('COM_VIRTUEMART_PAYMENT_CANCELLED_BY_SHOPPER');
		$modelOrder->updateStatusForOneOrder ($virtuemart_order_id, $order, TRUE);
				}
	}




function update_cart($token,$PayerID)
{

$db = JFactory::getDbo();
$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalplusssc" AND `published` = 1';
$db->setQuery($q);
$virtuemart_paymentmethod_id = $db->loadResult();
$method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);

if($virtuemart_paymentmethod_id == null)
{
return;
}

$session = JFactory::getSession();
$session->set('session_token', $token);
$session->set('session_PayerID', $PayerID);

$session_token = $session->get('session_token');


$APIrequest =
"&TOKEN=" . $token .

"&PAYMENTACTION=" . $method->ssc_payment_action;











$httpResponse = $this->PPHttpPost($method,"GetExpressCheckoutDetails", $APIrequest);









$first_name = '';
$middle_name ='';
$last_name = '';
$address_1 = '';
$address_2 = '';
$house_no = '';
$zip = '';
$city = '';
$state_name='';
$state_id='0';
$virtuemart_country_id='';
$phone_1='';
$email = '';


if(isset($httpResponse['FIRSTNAME']))
	{
	$first_name = urldecode($httpResponse['FIRSTNAME']);
	}

if(isset($httpResponse['MIDDLENAME']))
	{
	$middle_name = urldecode($httpResponse['MIDDLENAME']);
	}

if(isset($httpResponse['LASTNAME']))
	{
	$last_name = urldecode($httpResponse['LASTNAME']);
	}


if(isset($httpResponse['FIRSTNAME']) && isset($httpResponse['LASTNAME']))
	{
	if(urldecode($httpResponse['SHIPTONAME']) == urldecode($httpResponse['FIRSTNAME']) . ' ' . urldecode($httpResponse['LASTNAME']))
		{
		$first_name = urldecode($httpResponse['FIRSTNAME']);
		$last_name = urldecode($httpResponse['LASTNAME']);
		}
	else
		{
		$shipToName = explode(' ', urldecode($httpResponse['SHIPTONAME']));
		$first_name = $shipToName[0];
		$last_name = '';
		if (count($shipToName) > 1)
			{
			$last_name = str_replace($first_name . ' ', '', urldecode($httpResponse['SHIPTONAME']));
			}
		}
	}	


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOSTREET']))
	{
	$address_1 = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTREET']);
	}


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOCITY']))
	{
	$city = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOCITY']);
	}

if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOZIP']))
	{
	$zip = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOZIP']);
	}
	
	
if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE']))
	{
	$cc = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE']);
	$virtuemart_country_id = ShopFunctions::getCountryIDByName($cc);
	}


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']))
	{
	$state_name = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']);
	
	
	if(strlen($state_name) === 2)
		{
		$q = 'SELECT `virtuemart_state_id` FROM `#__virtuemart_states` WHERE `state_2_code`="' . $state_name . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$state_id_2 = $db->loadResult();
		
		if(!is_null($state_id_2))
			{
			$state_id = $state_id_2;
			}
		
				$city = trim($city);	
		}
	
	if(strlen($state_name) > 2)
		{
		$q = 'SELECT `virtuemart_state_id` FROM `#__virtuemart_states` WHERE `state_name`="' . $state_name . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$state_id_3 = $db->loadResult();
		
		if(!is_null($state_id_3))
			{
			$state_id = $state_id_3;
			}
		else
			{
			$city .= ' ' . urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']);
			$city = trim($city);	
			}
		}

	}

	

if(isset($httpResponse['PHONENUM']))
	{
	$phone_1 = urldecode($httpResponse['PHONENUM']);
	}


	
if(isset($httpResponse['EMAIL']))
	{
	$email = urldecode($httpResponse['EMAIL']);
	}




if(!class_exists('VirtueMartCart')) require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php');
		$cart = VirtueMartCart::getCart();


$address_type='BT';
$cart->STsameAsBT = 1;
$prefix = '';

if(isset($cart->BT['last_name']))
	{
	$address_type='ST';
	$prefix = 'shipto_';
	$cart->STsameAsBT = 0;
	}


$update_data = array(
$prefix . 'address_type_name'     => 'PayPal Shipping Address',
$prefix . 'company'               => '',
$prefix . 'title'                 => '',
$prefix . 'first_name'            => $first_name,
$prefix . 'middle_name'           => $middle_name,
$prefix . 'last_name'             => $last_name,
$prefix . 'address_1'             => $address_1,
$prefix . 'address_2'             => $address_2,
$prefix . 'house_no'              => '',
$prefix . 'zip'                   => $zip,
$prefix . 'city'                  => $city,
$prefix . 'virtuemart_country_id' => $virtuemart_country_id,
$prefix . 'virtuemart_state_id'   => $state_id,
$prefix . 'phone_1'               => $phone_1,
$prefix . 'phone_2'               => '',
$prefix . 'fax'                   => '',
$prefix . 'birthday'              => '',
$prefix . 'socialNumber'          => '',
'address_type'                    => $address_type
);


if ($address_type === 'BT')
	{
	$update_data['email'] = $email;
	}




	

$cart->saveAddressInCart($update_data, $update_data['address_type']);

$cart = VirtueMartCart::getCart ();
$cart->setCartIntoSession();



$extension_id='17';	
	
	try
	{	 
	$db = JFactory::getDBO();
	$query =
	"SELECT " . $db->quoteName('virtuemart_userfield_id') .
	" FROM " . $db->quoteName('#__virtuemart_userfields') .
	" WHERE " . $db->quoteName('name') ." = " . $db->quote('virtuemart_state_id').";";
	$db->setQuery($query);
	$extension_id = $db->loadResult();
	}
	catch (Exception $e)
		{
						    			}


if($state_id === '' || $state_id == '0')
	{
	try
		{
	
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		$fields = array($db->quoteName('required') . '=0');
	
		$conditions = array($db->quoteName('virtuemart_userfield_id') . '=' . $extension_id);
			
		$query->update($db->quoteName('#__virtuemart_userfields'))->set($fields)->where($conditions);
		$db->setQuery($query);
		$result = $db->query();
		}
	catch (Exception $e)
		{
						    			}
	
	
	}

$url= $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&amp;view=cart&amp;task=checkout&amp;mes=exp');



$ver = VmConfig::getInstalledVersion();
echo '<script type="text/javascript">
document.cookie = "c=1;path=/";
</script>
';


if($ver < '2.9')
	{
	print '
<form method="post" id="checkoutForm" name="checkoutForm" action="' . $url . '">';
	print "
	<input type='hidden' id='token' name='token' value='$token'/>
	<input type='hidden' name='PayerID' value='$PayerID'/>
	<input type='hidden' id='STsameAsBT' name='STsameAsBT' value='" . $cart->STsameAsBT . "'/>
	<input type='hidden' name='task' value='checkout'/>
	<input type='hidden' name='option' value='com_virtuemart'/>
	<input type='hidden' name='view' value='cart'/>
	<input type='submit' value='Connecting to server: Please wait'/>
	</form>";
	}



$url= $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&amp;view=cart&amp;mes=exp');

if($ver >= '2.9')
	{
	print '
	<form method="post" id="checkoutForm" name="checkoutForm" action="' . $url . '">';

	print "
	<input type='hidden' name='token' value='$token'/>
	<input type='hidden' name='PayerID' value='$PayerID'/>
	<input type='hidden' name='task' value='updatecart'/>
	<input type='hidden' name='option' value='com_virtuemart'/>
	<input type='hidden' name='view' value='cart'/>
	<input type='submit' value='Connecting to server: Please wait'/>
	</form>";
	}
	



if(!$method->debug)
   {
   print '<script type="text/javascript">';
   print 'document.checkoutForm.submit();';
   print '</script>';
   }

if($method->debug)
	{
	echo '<span style="color: ' . '#' . 'FF0000">';
	echo "<br/>You have enabled debugging in setup. Turn it off to remove the debug information below<br/>1<br/>";
	echo '</span>';
		echo("Http Response: " . print_r($httpResponse, true));
	echo '<br/>';
				
	}

$hidessc = "<style>
img#hidessc + h1
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + h3
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + div > h3:first-child
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<img id='hidessc'/>
";

echo $hidessc;

}





function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {
    

	if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
	    return null; 	}
	if (!$this->selectedThisElement($method->payment_element)) {
	    return false;
	}                                                                                                       
	$this->getPaymentCurrency($method);
	$paymentCurrencyId = $method->payment_currency;
    }


function plgVmOnPaymentResponseReceived(&$html)
{
    
if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );

		
	$order_data = $this->get_strings();

	
			
					
		
		
	$post_data = $this->post_strings();

	
	
		$jinput =JFactory::getApplication()->input;
	 
	$value='ecoplus'; $order_data[$value] = $jinput->get->get($value, null, 'ALNUM');
	$value='pectransid'; $order_data[$value] = $jinput->get->get($value, null, 'CMD');
	$value='e'; $order_data[$value] = $jinput->get->get($value, null, 'ALNUM');
	$value='token'; $order_data[$value] = $jinput->get->get($value, null, 'CMD');
	$value='PayerID'; $order_data[$value] = $jinput->get->get($value, null, 'CMD');
	
	$value='paymentId'; $order_data[$value] = $jinput->get->get($value, null, 'CMD');

	$value='s'; $post_data[$value] = $jinput->post->get($value, null, 'ALNUM');
	
	

	if (isset($post_data["s"]))
	   {
	   if($post_data["s"] == 'ecpplus')
	      {
          $this->doexpress('','','');
  	      return;
	      }
	   }


   if (isset($order_data["ecoplus"]))
	   {
	   
	   if(!class_exists('VirtueMartCart')) require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php');
		$cart = VirtueMartCart::getCart();
		
		$value = $this->plgVmConfirmedOrder($cart,null);

	   return $value;
	   }



	if (!isset($order_data["pectransid"]))
	   {
	   return;
	   }



if (isset($order_data["e"]) && $order_data["e"] === '1')
   {
		$this->update_cart($order_data['token'],$order_data['PayerID']);
	return;
	}

	$order_number = $order_data["pectransid"];
	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_data["pectransid"]);

	if (!$virtuemart_order_id)
	  {
	  return;
	  }

	
	$vendorId = 0;
	$payment = $this->getDataByOrderId($virtuemart_order_id);
	
		if($payment == null)
		{
		return false;
		}

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	
	if (!$this->selectedThisElement($method->payment_element))
		{
						return false;
		}
	
	

if(isset($order_data["paymentId"]))
	{
	
	if (!isset($order_data["PayerID"]))
	   {
	   echo 'PayerID is not Set';
	   return;
	   }
	
	$this->process_success($order_data["paymentId"],$order_data["PayerID"],$order_number);
	return;
	}

	

if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
	    $modelOrder = new VirtueMartModelOrders();
	    
	    $order = $modelOrder->getOrder($virtuemart_order_id);







$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$order_total=0;
$total_discount=0;
$total_tax=0;
$total_shipping=0;

$table='';

$customer_currency = 0;

	$customer_currency = trim($payment->alt_currency);


list($table,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details,$pppitems) = $this->order_form($order,$method,$customer_currency);

$APIrequest =
"&TOKEN=" . $order_data['token'] .

"&PAYMENTACTION=" . $method->ssc_payment_action;














$httpResponse = $this->PPHttpPost($method,"GetExpressCheckoutDetails", $APIrequest);



$method->ssc_address_override=1;

if($method->ssc_address_override == 0)
{
$first_name = '';
$middle_name ='';
$last_name = '';
$address_1 = '';
$address_2 = '';
$house_no = '';
$zip = '';
$city = '';
$state_name='';
$state_id='0';
$virtuemart_country_id='';
$phone_1='';
$email = '';


if(isset($httpResponse['FIRSTNAME']))
	{
	$first_name = urldecode($httpResponse['FIRSTNAME']);
	}

if(isset($httpResponse['MIDDLENAME']))
	{
	$middle_name = urldecode($httpResponse['MIDDLENAME']);
	}

if(isset($httpResponse['LASTNAME']))
	{
	$last_name = urldecode($httpResponse['LASTNAME']);
	}

if(isset($httpResponse['FIRSTNAME']) && isset($httpResponse['LASTNAME']))
	{
	if(urldecode($httpResponse['SHIPTONAME']) == urldecode($httpResponse['FIRSTNAME']) . ' ' . urldecode($httpResponse['LASTNAME']))
		{
		$first_name = urldecode($httpResponse['FIRSTNAME']);
		$last_name = urldecode($httpResponse['LASTNAME']);
		}
	else
		{
		$shipToName = explode(' ', urldecode($httpResponse['SHIPTONAME']));
		$first_name = $shipToName[0];
		$last_name = '';
		if (count($shipToName) > 1)
			{
			$last_name = str_replace($first_name . ' ', '', urldecode($httpResponse['SHIPTONAME']));
			}
		}
	}


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOSTREET']))
	{
	$address_1 = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTREET']);
	}


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOCITY']))
	{
	$city = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOCITY']);
	}

if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOZIP']))
	{
	$zip = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOZIP']);
	}
	
	
if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE']))
	{
	$cc = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE']);
	$virtuemart_country_id = ShopFunctions::getCountryIDByName($cc);
	}


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']))
	{
	$state_name = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']);
	
	
	if(strlen($state_name) === 2)
		{
		$q = 'SELECT `virtuemart_state_id` FROM `#__virtuemart_states` WHERE `state_2_code`="' . $state_name . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$state_id_2 = $db->loadResult();
		
		if(!is_null($state_id_2))
			{
			$state_id = $state_id_2;
			}
		
				$city = trim($city);	
		}
	
	if(strlen($state_name) > 2)
		{
		$q = 'SELECT `virtuemart_state_id` FROM `#__virtuemart_states` WHERE `state_name`="' . $state_name . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$state_id_3 = $db->loadResult();
		
		if(!is_null($state_id_3))
			{
			$state_id = $state_id_3;
			}
		else
			{
			$city .= ' ' . urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']);
			$city = trim($city);	
			}
		}

	}

	
	
if(isset($httpResponse['PHONENUM']))
	{
	$phone_1 = urldecode($httpResponse['PHONENUM']);
	}
	
	
if(isset($httpResponse['EMAIL']))
	{
	$email = urldecode($httpResponse['EMAIL']);
	}




$bt=0;
$st=0; 
  
$db = JFactory::getDBO();
$query = $db->getQuery(true);
$query->select($db->quoteName(array('virtuemart_order_userinfo_id','virtuemart_order_id','virtuemart_user_id','address_type')));
$query->from($db->quoteName('#__virtuemart_order_userinfos'));
$query->where(array($db->quoteName('virtuemart_order_id')." = " . $virtuemart_order_id,$db->quoteName('address_type') . '=' . $db->quote('ST')));
$db->setQuery($query);
$db->query();
$st = $db->getNumRows();


$db = JFactory::getDBO();
$query = $db->getQuery(true);
$query->select($db->quoteName(array('virtuemart_order_userinfo_id','virtuemart_order_id','virtuemart_user_id','address_type','address_type_name','company','title','last_name','first_name','middle_name','phone_1','phone_2','fax','address_1','address_2','city','virtuemart_state_id','virtuemart_country_id','zip','email','agreed','created_on','created_by','modified_on','modified_by','locked_on','locked_by')));
$query->from($db->quoteName('#__virtuemart_order_userinfos'));
$query->where(array($db->quoteName('virtuemart_order_id')." = " . $virtuemart_order_id,$db->quoteName('address_type') . '=' . $db->quote('BT')));
$db->setQuery($query);
$row = $db->loadObject();
$db->query();
$bt = $db->getNumRows();   
   

if($bt == 1 && $st == 1)
	{
	$db = JFactory::getDBO();
	$query = $db->getQuery(true);
		$fields = array($db->quoteName('first_name') . '=' . $db->quote($first_name),
	$db->quoteName('last_name') . '=' . $db->quote($last_name),
	$db->quoteName('middle_name') . '=' . $db->quote($middle_name),
	$db->quoteName('last_name') . '=' . $db->quote($last_name),
	$db->quoteName('address_1') . '=' . $db->quote($address_1),
	$db->quoteName('address_2') . '=' . $db->quote($address_2),
	$db->quoteName('zip') . '=' . $db->quote($zip),
	$db->quoteName('city') . '=' . $db->quote($city),
	$db->quoteName('virtuemart_state_id') . '=' . $state_id,
	$db->quoteName('virtuemart_country_id') . '=' . $virtuemart_country_id,
	$db->quoteName('phone_1') . '=' . $db->quote($phone_1),
	$db->quoteName('email') . '=' . $db->quote($email));
	$conditions = array($db->quoteName('virtuemart_order_id') . '=' . $virtuemart_order_id,$db->quoteName('address_type') . '=' . $db->quote('ST'));
	$query->update($db->quoteName('#__virtuemart_order_userinfos'))->set($fields)->where($conditions);
	$db->setQuery($query);
	$result = $db->query();
	}


if($bt == 1 && $st == 0)
	{
	$row->virtuemart_order_userinfo_id = null;
	$row->address_type='ST'; 
	$row->first_name = $first_name;
	$row->last_name = $last_name;
	$row->middle_name = $middle_name;
	$row->last_name = $last_name;
	$row->address_1 = $address_1;
	$row->address_2 = $address_2;
	$row->zip = $zip;
	$row->city = $city;
	$row->virtuemart_state_id = $state_id;
	$row->virtuemart_country_id = $virtuemart_country_id;
	$row->phone_1 = $phone_1;
	$row->email = $email;
	$result = JFactory::getDbo()->insertObject('#__virtuemart_order_userinfos', $row);
	}
	$order = $modelOrder->getOrder($virtuemart_order_id);
}












if($method->ssc_user_action === "commit")
	{
	$this->doexpress(urldecode($httpResponse['TOKEN']),urldecode($httpResponse['PAYERID']),$order_data["pectransid"]);   
	return null;   
	}

if("SUCCESS" == strtoupper($httpResponse["ACK"]) || "SUCCESSWITHWARNING" == strtoupper($httpResponse["ACK"]))
   {
   print "<p style='font-size: x-large'>" . JText::_('VMPAYMENT_PPP_SSC_REVIEW') . "</p>";


$url = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived');

$button =  
"<form method='POST' action='" . $url . "' onsubmit='return Form_Validator(this)'>
<input type='hidden' name='token' value='" . urldecode($httpResponse['TOKEN']) . "'>" .
"<input type='hidden' name='s' value='ecpplus'>" .
"<input type='hidden' name='PAYERID' value='" . urldecode($httpResponse['PAYERID']) . "'>" .

"<input type='hidden' name='pectransid' value='" . $order_data["pectransid"] . "'>" .

"<input type='submit' value='" . JText::_('VMPAYMENT_PPP_SSC_PLACE_ORDER') . "' name='B1'>" . 
"</form>";
   
   
echo $button;
echo '<br/>';
echo $table;

$address = $order['details']['BT'];

$del_address = null;
	
	if(isset($order['details']['ST']))
	   {
	   $del_address = $order['details']['ST'];
	   }
	else
	   {
	   $del_address = $order['details']['BT'];
	   }

$country = ShopFunctions::getCountryByID($address->virtuemart_country_id, "country_2_code");
$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";


$del_country = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, "country_2_code");
$del_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id) : "";


list($order_form,$order_form_html_billing,$order_form_html_shipping) = $this->billing_shipping_address($address,$del_address,$country,$del_country,$cc_state,$del_state);

echo '<br/>';

$show_shipping=1;

print '<table style="width: 600px" cellspacing="0" cellpadding="2">';
print '<tr><td style="border-style:hidden" valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';


print '<br/><b>&nbsp;&nbsp;&nbsp;&nbsp;' . JText::_('VMPAYMENT_PPP_SSC_BILLING_ADDRESS')  . '</b><br/>';
echo $order_form_html_billing;

print '</td><td style="border-style:hidden" valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';

if($show_shipping == 1)
	{
	print '<br/><b>&nbsp;' . JText::_('VMPAYMENT_PPP_SSC_SHIPPING_ADDRESS') . '</b><br/>';
		echo $order_form_html_shipping;
	}

print '</td></tr></table>';

	
if($method->debug)
	{
	$real_shipping = $this->real_shipping_address($httpResponse); 
	echo "PayPal's Shipping Address:<br>" . $real_shipping . '<br>';
	}


print $button;
 

$html="";

		

   }
else
   {
   $s=0;
   $error ="No";
         print "<span style='font-family: Arial, Helvetica, sans-serif; font-size: large; color: #FF0000'>";
   while(isset($httpResponse["L_LONGMESSAGE" . $s]))
   {

   
   if($httpResponse["L_ERRORCODE" . $s] == "500")
      {
	  print JText::_('VMPAYMENT_PPP_SSC_UNKNOWN_ERROR');   
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "81234")
      {
      print "";        
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10002" && $httpResponse["L_LONGMESSAGE" . $s] == 'Security%20header%20is%20not%20valid')
      {
      print "Please check your API Username, Password and Signature for your Live or Sandbox account.";	         
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10002" && $httpResponse["L_LONGMESSAGE" . $s] == 'You%20do%20not%20have%20permissions%20to%20make%20this%20API%20call')
      {
      print "Do you have a valid Payments Pro Live or Sandbox account with the correct API Username, Password and Signature";	         
      }      
   else
      {
   
      if($error == 'No')
         {      
         print "<br>" . JText::_('VMPAYMENT_PPP_SSC_TRY_AGAIN') . ".<br>";
         $error='Yes';
         }
         	         
      print $httpResponse["L_ERRORCODE" . $s] . ": " . urldecode($httpResponse["L_LONGMESSAGE" . $s]) . " <br><br>\r\n";  
      }
   $s++;
     
   }
    print "<br></span><br>";
}
	
$hidessc = "<style>
img#hidessc + h1
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + h3
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + div > h3:first-child
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<img id='hidessc'/>
";

echo $hidessc;
	

    
    return null; 
    
    }


function plgVmOnUserPaymentCancel()
	{

	if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );


	
	$jinput =JFactory::getApplication()->input;
	$order_number = $jinput->get->get('on', null, 'CMD');
	$virtuemart_paymentmethod_id = $jinput->get->get('pm', null, 'CMD');


	if (empty($order_number) or empty($virtuemart_paymentmethod_id) or !$this->selectedThisByMethodId($virtuemart_paymentmethod_id))
		{
		return NULL;
		}
   
	if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number)))
		{
		return NULL;
		}
   
   if (!($paymentTable = $this->getDataByOrderNumber($order_number)))
		{
		return NULL;
		}

			
	$method = $this->getPluginMethod($virtuemart_paymentmethod_id);
	$mod = VmModel::getModel('orders');
	$order = $mod->getOrder($virtuemart_order_id);
	if ($order['details']['BT']->order_status == $method->status_success) 		{
		return NULL;
		}
		
	if ($order['details']['BT']->order_status != $method->status_pending) 		{
		return NULL;
		}
		    
	$session = JFactory::getSession();
	$return_context = $session->getId();
	if (strcmp($paymentTable->paypal_custom, $return_context) === 0)
		{
		VmInfo(Jtext::_('VMPAYMENT_PPP_SSC_PAYMENT_CANCELLED'));
		$this->handlePaymentUserCancel($virtuemart_order_id);
		}    
	    

	return true;
    }






function PPHttpPost($method,$methodName_, $nvpStr_) {

	if(!ini_get('safe_mode'))
		{
		if(ini_get('max_execution_time') < 45)
			{ 
			if(false === strpos(ini_get("disable_functions"), "set_time_limit"))
				{
								set_time_limit(45);
				}
													}
		}
		
			
	
	$API_UserName = trim($method->ssc_api_username);
	$API_Password = trim($method->ssc_api_password);
	$API_Signature = trim($method->ssc_api_signature);
	$API_Endpoint = "https://api-3t.paypal.com/nvp";
	
	$d = 0;
	
	if($method->ssc_environment === "sandbox" || $d == 1)
		{
		$API_UserName = trim($method->ssc_api_sb_username);
		$API_Password = trim($method->ssc_api_sb_password);
		$API_Signature = trim($method->ssc_api_sb_signature);
   	$API_Endpoint = "https://api-3t.sandbox.paypal.com/nvp";
		}
	

	$version = urlencode('114.0');

		$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $API_Endpoint);
	curl_setopt($ch, CURLOPT_VERBOSE, 1);

		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);

	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_POST, 1);
	
		curl_setopt($ch, CURLOPT_TIMEOUT,35);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 35);


		$nvpreq = "METHOD=$methodName_&VERSION=$version&PWD=$API_Password&USER=$API_UserName&SIGNATURE=$API_Signature$nvpStr_";


		curl_setopt($ch, CURLOPT_POSTFIELDS, $nvpreq);

		$httpResponse = curl_exec($ch);

	if(!$httpResponse) {
		exit("$methodName_ failed: ".curl_error($ch).'('.curl_errno($ch).')');
	}

		$httpResponseAr = explode("&", $httpResponse);

	$httpParsedResponseAr = array();
	foreach ($httpResponseAr as $i => $value) {
		$tmpAr = explode("=", $value);
		if(sizeof($tmpAr) > 1) {
			$httpParsedResponseAr[$tmpAr[0]] = $tmpAr[1];
		}
	}

	if((0 == sizeof($httpParsedResponseAr)) || !array_key_exists('ACK', $httpParsedResponseAr)) {
		exit("Invalid HTTP Response for POST request($nvpreq) to $API_Endpoint.");
	}

	return $httpParsedResponseAr;
}




function billing_shipping_address($address,$del_address,$country,$del_country,$state,$del_state)
{


 $pageURL = 'http';

if(isset($_SERVER["HTTPS"]))
 if ($_SERVER["HTTPS"] == "on") {$pageURL .= "s";};


 $pageURL .= "://";
 if ($_SERVER["SERVER_PORT"] != "80") {
  $pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
 } else {
  $pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
 }
$form_url = $pageURL;


$billing_script_name = $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=BT';

$shipping_script_name = $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=ST';

$order_data = $this->post_strings();


$cc_month='00';
$cc_year='00';
$cc_security_code='';
$cc_type='';
$cc_number='';

if(isset($order_data['cc_month']))
   {
   $cc_month=$order_data['cc_month'];
   }
 
if(isset($order_data['cc_year']))
   {
   $cc_year=$order_data['cc_year'];
   }


if(isset($order_data['cc_security_code']))
   {
   $cc_security_code=$order_data['cc_security_code'];
   }


if(isset($order_data['cc_type']))
   {
   $cc_type=$order_data['cc_type'];
   }

if(isset($order_data['cc_number']))
   {
   $cc_number=$order_data['cc_number'];
   }



$currency_code = 'USD';

$credit_cards=
'<option value="Visa">Visa</option>
<option value="MasterCard">MasterCard</option>
<option value="Discover">Discover</option>
<option value="Amex">American Express</option>
'; 

$start_date = '';
$issue_number = '';

if($currency_code == 'GBP')
   {

$start_date = '<tr>
       <td style="border-style:hidden" align="right">Start Date: Maestro/Solo Only:&nbsp; </td>
       <td style="border-style:hidden" align="left" ><select name="cc_start_month" size="1">
        <option value=""> Month </option>
        <option value="01">01</option>
        <option value="02">02</option>
        <option value="03">03</option>
        <option value="04">04</option>
        <option value="05">05</option>
        <option value="06">06</option>
        <option value="07">07</option>
        <option value="08">08</option>
        <option value="09">09</option>
        <option value="10">10</option>
        <option value="11">11</option>
        <option value="12">12</option>
      </select><select name="cc_start_year" size="1">
        <option value=""> Year </option>
        <option value="2011">2011</option>
        <option value="2010">2010</option>
        <option value="2009">2009</option>
        <option value="2008">2008</option>
        <option value="2007">2007</option>
        <option value="2006">2006</option>
        <option value="2005">2005</option>
        <option value="2004">2004</option>
        <option value="2003">2003</option>
        <option value="2002">2002</option>
        <option value="2001">2001</option>
        <option value="2000">2000</option>
      </select></td>
    </tr>';


$issue_number = '
   <tr>
       <td style="border-style:hidden" align="right">Issue Number: Maestro/Solo Only:&nbsp; </td>
       <td style="border-style:hidden" align="left"><input
      name="cc_issue_number" size="3" MAXLENGTH="2" type="text"></td>
    </tr>';
    
$credit_cards .= '<option value="Solo">Solo</option>
   <option value="Switch">Maestro</option>';
	
   }        	
	
    
$order_form_html = <<<directorderform

<script language="JavaScript">
<!--

var submitted = 0;


      
function Form_Validator(theForm)
{
if(submitted==1)
   {
   alert("You have already submitted this form");
   return false;
   }

if (theForm.cc_number.value == "")
  {
    alert("Please enter a credit card number.");
    theForm.cc_number.focus();
    return (false);
  }

if (theForm.cc_security_code.value == "")
  {
    alert("Please enter a Security Code (CVV).");
    theForm.cc_security_code.focus();
    return (false);
  }

  if(submitted==0)
    {
    //form.submitit.disabled=true;
    submitted = 1;
    }

  return (true);
}
//--></script>


<form method="post" action="$form_url" name="Form1"
onsubmit="return Form_Validator(this)">
directorderform;


$editbillingaddress =  JText::_('VMPAYMENT_PPP_SSC_EDIT_BILLING_ADDRESS');
$order_form_name = JText::_('VMPAYMENT_PPP_SSC_NAME');
$order_form_address = JText::_('VMPAYMENT_PPP_SSC_ADDRESS');
$order_form_city = JText::_('VMPAYMENT_PPP_SSC_CITY');
$order_form_state = JText::_('VMPAYMENT_PPP_SSC_STATE');
$order_form_country = JText::_('VMPAYMENT_PPP_SSC_COUNTRY');
$order_form_zip = JText::_('VMPAYMENT_PPP_SSC_ZIP');
$order_form_telephone = JText::_('VMPAYMENT_PPP_SSC_TELEPHONE');
$order_form_email = JText::_('VMPAYMENT_PPP_SSC_EMAIL');
$order_form_paypal_billing_address = JText::_('VMPAYMENT_PPP_SSC_PAYPAL_BILLING_ADDRESS');
$order_form_item_total = JText::_('VMPAYMENT_PPP_SSC_ITEM_TOTAL');
$order_form_tax = JText::_('VMPAYMENT_PPP_SSC_TAX');
$order_form_surcharge = JText::_('VMPAYMENT_PPP_SSC_SURCHARGE');
$order_form_shipping = JText::_('VMPAYMENT_PPP_SSC_SHIPPING');
$order_form_order_total = JText::_('VMPAYMENT_PPP_SSC_ORDER_TOTAL');


$order_form_html_billing = <<<directorderform
 
<table cellspacing="0" cellpadding="2">
<tbody>
       
    <tr>
       <td style="border-style:hidden" colspan="2"></td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_name:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
      
$address->first_name $address->last_name 
      
</td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_address:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
      
$address->address_1     
      
      </td>
    </tr>
    <tr>
directorderform;
    
    
if($address->address_2 != '')    
{    
$order_form_html_billing .=
<<<directorderform
    <tr align="center">
       <td style="border-style:hidden" align="right"></td>
       <td style="border-style:hidden" align="left" >&nbsp;
$address->address_2
      </td>
    </tr>
directorderform;

}

   
    
$order_form_html_billing .=
<<<directorderform
    <tr>
       <td style="border-style:hidden" align="right">$order_form_city:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$address->city   
     </td>
    </tr>
directorderform;
    
    
if($state != '')    
{
$order_form_html_billing .=
<<<directorderform
	<tr>
		<td style="border-style:hidden" align="right">$order_form_state:</td>
		<td style="border-style:hidden" align="left" >&nbsp;$state</td>
	</tr>
directorderform;
}
    
$order_form_html_billing .= <<<directorderform
    <tr>
       <td style="border-style:hidden" align="right">$order_form_country:</td>    
      
       <td style="border-style:hidden" align="left" >&nbsp;
$country
      </td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_zip:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$address->zip 
</td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_email:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$address->email
      </td>
      </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_telephone:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$address->phone_1
      </td>
    </tr>
    <tr>
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left"></td>
    </tr>
   </tbody>
  </table>
directorderform;

    
$editshippingaddress =  JText::_('VMPAYMENT_PPP_SSC_EDIT_SHIPPING_ADDRESS');

    
$order_form_html_shipping = <<<directorderform
<table cellspacing="0" cellpadding="2">
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_name:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->first_name $del_address->last_name
      </td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_address:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->address_1      
      </td>
    </tr>
directorderform;


if($del_address->address_2 != '')    
{    
$order_form_html_shipping .=
<<<directorderform
    <tr align="center">
       <td style="border-style:hidden" align="right"></td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->address_2
      </td>
    </tr>
directorderform;
}


$order_form_html_shipping .=
<<<directorderform
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_city:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->city
      </td>
    </tr>
directorderform;
    
    
if($del_state != '')    
{
$order_form_html_shipping .=
<<<directorderform
	<tr>
		<td style="border-style:hidden" align="right">$order_form_state:</td>
		<td style="border-style:hidden" align="left" >&nbsp;$del_state</td>
	</tr>
directorderform;
}
    
$order_form_html_shipping .= <<<directorderform
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_country:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_country      
      </td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_zip:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->zip
      </td>
    </tr>

    <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left" ></td>
    </tr>
    
    <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left"></td>
    </tr>
    
   </tbody>
  </table>
directorderform;

$credit_card_html = <<<directorderform
<table cellspacing="0" cellpadding="2">

  <tr>
       <td style="border-style:hidden" colspan="2" align="center" ><strong>Credit/Debit Card Details</strong></td>
      
  </tr>

  <tr>
       <td style="border-style:hidden" align="right">Credit/Debit Card
      Type:&nbsp; </td>
       <td style="border-style:hidden" align="left" >
      <select name="cc_type" size="1"  style="border: 1px solid #000000; margin: 2px;"; margin: 2px;">

$credit_cards

	 </select></td></tr>
    <tr>
       <td style="border-style:hidden" align="right">Card
      Number:&nbsp; </td>
       <td style="border-style:hidden" align="left" ><input name="cc_number" value="$cc_number" size="40" type="text" style="border: 1px solid #000000; margin: 2px;"></td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">Security Code
      (CVV):&nbsp; </td>
       <td style="border-style:hidden" align="left" ><input
      name="cc_security_code" value="$cc_security_code" size="4" maxlength="4" type="text"  style="border: 1px solid #000000; margin: 2px;"></td>
    </tr><tr>
    
$issue_number
    
$start_date
directorderform;
    
$expiry_date = '<td style="border-style:hidden" align="right">Expiry Date:&nbsp; </td>
       <td style="border-style:hidden" align="left" ><select name="cc_month" size="1" style="border: 1px solid #000000; margin: 2px;">
         <option value="00"> Month </option>
        <option value="01">01</option>
        <option value="02">02</option>
        <option value="03">03</option>
        <option value="04">04</option>
        <option value="05">05</option>
        <option value="06">06</option>
        <option value="07">07</option>
        <option value="08">08</option>
        <option value="09">09</option>
        <option value="10">10</option>
        <option value="11">11</option>
        <option value="12">12</option>';
        
              
$expiry_date = str_replace("value=\"$cc_month", "selected value=\"$cc_month", $expiry_date);

        
$expiry_year =         
      '</select><select name="cc_year" size="1"  style="border: 1px solid #000000; margin: 2px;">
        <option value="00"> Year </option>
        <option value="2010">2010</option>
        <option value="2011">2011</option>
        <option value="2012">2012</option>
        <option value="2013">2013</option>
        <option value="2014">2014</option>
        <option value="2015">2015</option>
        <option value="2016">2016</option>
        <option value="2017">2017</option>
        <option value="2018">2018</option>
        <option value="2019">2019</option>
        <option value="2020">2020</option>
        <option value="2021">2021</option>
        <option value="2022">2022</option>
      </select></td>';
      

$expiry_year = str_replace("value=\"$cc_year", "selected value=\"$cc_year", $expiry_year);      
      
$credit_card_html .= <<<directorderform
$expiry_date
$expiry_year 
    </tr>
       <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left" ></td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left" ><input
      value="Place Order" name="B1" type="submit"> <input value="Reset" name="B2" type="reset">&nbsp;
      </td>
    </tr>
  </table>
<input type='hidden' name='task' value='confirm'/>
		<input type='hidden' name='option' value='com_virtuemart'/>
		<input type='hidden' name='view' value='cart'/>
</form>
<p align="center">&nbsp;</p>
directorderform;

$order_form_html .= $order_form_html_billing . $credit_card_html;

return array($order_form_html,$order_form_html_billing,$order_form_html_shipping);

}


function shipping_address_html($del_address,$del_country,$del_state)
{

$editbillingaddress =  JText::_('VMPAYMENT_PPP_SSC_EDIT_BILLING_ADDRESS');
$order_form_name = JText::_('VMPAYMENT_PPP_SSC_NAME');
$order_form_address = JText::_('VMPAYMENT_PPP_SSC_ADDRESS');
$order_form_city = JText::_('VMPAYMENT_PPP_SSC_CITY');
$order_form_state = JText::_('VMPAYMENT_PPP_SSC_STATE');
$order_form_country = JText::_('VMPAYMENT_PPP_SSC_COUNTRY');
$order_form_state = JText::_('VMPAYMENT_PPP_SSC_STATE');
$order_form_zip = JText::_('VMPAYMENT_PPP_SSC_ZIP');
$order_form_telephone = JText::_('VMPAYMENT_PPP_SSC_TELEPHONE');
$order_form_email = JText::_('VMPAYMENT_PPP_SSC_EMAIL');
$order_form_paypal_billing_address = JText::_('VMPAYMENT_PPP_SSC_PAYPAL_BILLING_ADDRESS');
$order_form_item_total = JText::_('VMPAYMENT_PPP_SSC_ITEM_TOTAL');
$order_form_tax = JText::_('VMPAYMENT_PPP_SSC_TAX');
$order_form_surcharge = JText::_('VMPAYMENT_PPP_SSC_SURCHARGE');
$order_form_shipping = JText::_('VMPAYMENT_PPP_SSC_SHIPPING');
$order_form_order_total = JText::_('VMPAYMENT_PPP_SSC_ORDER_TOTAL');


$order_form_html_shipping = <<<directorderform
<table cellspacing="0" cellpadding="2">
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_name:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->first_name $del_address->last_name
      </td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_address:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->address_1      
      </td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" align="right"></td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->address_2
      </td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_city:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->city
      </td>
    </tr>
directorderform;
    
    
if($del_state != '')    
{
$order_form_html_shipping .=
<<<directorderform
	<tr>
		<td style="border-style:hidden" align="right">$order_form_state:</td>
		<td style="border-style:hidden" align="left" >&nbsp;$del_state</td>
	</tr>
directorderform;
}
    

$order_form_html_shipping .= <<<directorderform
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_country:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_country      
      </td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_zip:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->zip
      </td>
    </tr>

    <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left" ></td>
    </tr>
    
    <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left" ></td>
    </tr>
    </tbody>
  </table>
directorderform;

return $order_form_html_shipping;
}






function plgVmOnPaymentNotification()
	{
	if (!class_exists('VirtueMartModelOrders'))
		{
		require(JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php');
		}
				
	$paypal_data_get = $this->get_strings();

	$paypal_data_post = $this->post_strings();
	
	$paypal_data = $paypal_data_get;


	foreach($paypal_data_post as $index => $value)
		{
		$paypal_data[$index] = $value;
		}

		
		
	if (!isset($paypal_data['invoice']))
		{
		return FALSE;
		}


	$order_number = $paypal_data['invoice'];
	
	if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($paypal_data['invoice'])))
		{
		return FALSE;
		}
			
	if (!($payments = $this->getDatasByOrderId($virtuemart_order_id)))
		{
		return FALSE;
		}
		
						
	$method = $this->getVmPluginMethod($payments[0]->virtuemart_paymentmethod_id);

	
		if (!($method = $this->getVmPluginMethod($payments[0]->virtuemart_paymentmethod_id)))
		{
				return NULL;
		}
	
	if(!$this->selectedThisByMethodId($payments[0]->virtuemart_paymentmethod_id))
		{
				return NULL;
		}		
	
	if (!$this->selectedThisElement($method->payment_element))
		{
		return FALSE;
		}
		
	if($method->ssc_ipn_updates != 1)
		{
		return null;
		}
		

	$modelOrder = VmModel::getModel('orders');
	$order = array();

	$order['customer_notified'] = 1;
	
	
$ipn_check = 1;

if($ipn_check == 1)
	{	
				$raw_post_data = file_get_contents('php://input');
	$raw_post_array = explode('&', $raw_post_data);
	$myPost = array();
	foreach ($raw_post_array as $keyval)
		{
		$keyval = explode ('=', $keyval);
		if (count($keyval) == 2)
		$myPost[$keyval[0]] = urldecode($keyval[1]);
		}
$req = 'cmd=_notify-validate';
if (function_exists('get_magic_quotes_gpc'))
	{
	$get_magic_quotes_exists = true;
	}

foreach ($myPost as $key => $value)
	{
	if ($get_magic_quotes_exists == true && get_magic_quotes_gpc() == 1)
		{
	  $value = urlencode(stripslashes($value));
		}
	else
		{
		$value = urlencode($value);
		}
		
	$req .= "&$key=$value";
	}
	

$paypal_url ="";

if($method->ssc_environment == "sandbox")
   {
   $paypal_url = "https://ipnpb.sandbox.paypal.com/cgi-bin/webscr";
   }
else
   {
   $paypal_url = "https://ipnpb.paypal.com/cgi-bin/webscr";
   }


		$ch = curl_init($paypal_url);
	
			
	curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
			
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
	
	
	curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);
	curl_setopt($ch, CURLOPT_HTTPHEADER, array('Connection: Close'));

					if (!($res = curl_exec($ch)))
		{
				curl_close($ch);
		echo 'Curl Error: ';
		return;
		}
	
	curl_close($ch);

		if ($res != "VERIFIED")
		{
		echo 'IPN is not verified';
		
		return null;
		}
	
						
		
		}	
	
	
	$check = 0;
			
	if($check == 1)
		{
		echo 'check dns hostname';
		$hostname = gethostbyaddr($_SERVER['REMOTE_ADDR']);
	
		$hostname = trim($hostname);
	
	if (preg_match('/\.paypal\.com$/i', $hostname))
				{
			if($method->debug)
				{
		    	echo "<br/>PayPal hostname is correct.";
		    	echo '<br>hostname ' . $hostname . '<br>';
		    	echo $_SERVER['REMOTE_ADDR'];
		    	}
			}
		else
			{
			if($method->debug)
				{
		    	echo "<br/>PayPal domain not matched. ";
				echo '<br>hostname ' . $hostname . '<br>';
		    	echo $_SERVER['REMOTE_ADDR']; 	    
		    	}
	    	
			$mailbody = "The following update to the order has been received but it can not be verifed if it came from PayPal.\n\n";
			$mailbody .= "Please log in to your PayPal server to confirm the order.\n\n";

			foreach ($paypal_data as $key => $value) {$mailbody .= $key . " = " . $value . "\n\n";}
		
					
			      
			return null;
			}
		}

		
		
				

	

	if ($paypal_data['payment_status'] == 'Refunded' && isset($method->status_refunded))
		{
		
		if ($payments[0]->payment_order_total == (-1*$paypal_data['mc_gross']))
			{
			echo 'Full Refund: '. $paypal_data['mc_gross'];
			$order['comments'] = JText::sprintf('VMPAYMENT_PAYPAL_PAYMENT_STATUS_REFUNDED', $order_number);
			$order['order_status'] = $method->status_refunded;
						$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
			}
		else
			{
			echo 'Partial Refund: ' . $paypal_data['mc_gross'];
			$order['comments'] = JText::sprintf('VMPAYMENT_PAYPAL_PAYMENT_STATUS_PARTIAL_REFUNDED', $order_number);
			$order['order_status'] = isset($method->status_partial_refunded) ? $method->status_partial_refunded:'R' ;
			$order['customer_notified'] = 0;	
			$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
			}
		
		
		return null;		
		}
		
	if ($paypal_data['payment_status'] == 'Partially_Refunded')
		{
		echo 'Partial Refund: ' . $paypal_data['mc_gross'];
		$order['comments'] = JText::sprintf('VMPAYMENT_PAYPAL_PAYMENT_STATUS_PARTIAL_REFUNDED', $order_number);
		$order['order_status'] = isset($method->status_partial_refunded) ? $method->status_partial_refunded:'R' ;
		$order['customer_notified'] = 0;
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
		return null;		
		}	
		
	
		
	if ($paypal_data['payment_status'] == 'Canceled_Reversal')
		{
		$order['order_status'] = $method->status_success;
		$order['comments'] = JText::sprintf($paypal_data['payment_status'], $order_number);
		$order['customer_notified'] = 0;
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
		return null;		
		}

	
	if ($paypal_data['payment_status'] == 'Denied' && isset($method->status_denied))
		{
		$order['comments'] = JText::sprintf('Denied', $order_number);
		$order['order_status'] = $method->status_denied;
				$order['comments'] = JText::sprintf($paypal_data['payment_status'], $order_number);
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
		return null;
		}
	
		
				
	
	if($paypal_data['payment_status'] === 'Expired' ||
		$paypal_data['payment_status'] === 'Declined' ||
		$paypal_data['payment_status'] === 'Failed' ||
		$paypal_data['payment_status'] ==='Reversed' ||
		$paypal_data['payment_status'] ==='Voided')
		{
				$order['comments'] = JText::sprintf($paypal_data['payment_status'], $order_number);
		$order['order_status'] = $method->status_canceled;
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
		}
	
		
return null;
	

}


function real_shipping_address($httpResponse) 
 {
 
$editbillingaddress =  JText::_('VMPAYMENT_PPP_SSC_EDIT_BILLING_ADDRESS');
$order_form_name = JText::_('VMPAYMENT_PPP_SSC_NAME');
$order_form_address = JText::_('VMPAYMENT_PPP_SSC_ADDRESS');
$order_form_city = JText::_('VMPAYMENT_PPP_SSC_CITY');
$order_form_state = JText::_('VMPAYMENT_PPP_SSC_STATE');
$order_form_country = JText::_('VMPAYMENT_PPP_SSC_COUNTRY');
$order_form_state = JText::_('VMPAYMENT_PPP_SSC_STATE');
$order_form_zip = JText::_('VMPAYMENT_PPP_SSC_ZIP');
$order_form_telephone = JText::_('VMPAYMENT_PPP_SSC_TELEPHONE');
$order_form_email = JText::_('VMPAYMENT_PPP_SSC_EMAIL');
$order_form_paypal_billing_address = JText::_('VMPAYMENT_PPP_SSC_PAYPAL_BILLING_ADDRESS');
$order_form_item_total = JText::_('VMPAYMENT_PPP_SSC_ITEM_TOTAL');
$order_form_tax = JText::_('VMPAYMENT_PPP_SSC_TAX');
$order_form_surcharge = JText::_('VMPAYMENT_PPP_SSC_SURCHARGE');
$order_form_shipping = JText::_('VMPAYMENT_PPP_SSC_SHIPPING');
$order_form_order_total = JText::_('VMPAYMENT_PPP_SSC_ORDER_TOTAL');
 
 
$SHIPTOSTREET2=''; 

if(isset($httpResponse["SHIPTOSTREET2"]))
	{
	$SHIPTOSTREET2=$httpResponse["SHIPTOSTREET2"];
	}

$PHONENUM=''; 
	if(isset($httpResponse["PHONENUM"]))
	{
	$PHONENUM=$httpResponse["PHONENUM"];
	}

 
 
$table =
'<table cellspacing="0" cellpadding="2">
<tbody>
 
    <tr>
    <tr>
       <td style="border-style:hidden" colspan="2"></td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_name:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .

urldecode($httpResponse['SHIPTONAME']) .

'</td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_address:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .

urldecode($httpResponse["SHIPTOSTREET"]) .

'      </td>
    </tr>
    <tr>
      <td></td>
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($SHIPTOSTREET2) .

'      </td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_city:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($httpResponse["SHIPTOCITY"]) .

'     </td>
    </tr><tr>
       <td style="border-style:hidden" align="right">$order_form_state:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($httpResponse["SHIPTOSTATE"]) .

'      </td>
    </tr><tr>
       <td style="border-style:hidden" align="right">$order_form_country:</td>    
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($httpResponse["COUNTRYCODE"]) .

'      </td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_zip:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .

urldecode($httpResponse["SHIPTOZIP"]) .

'</td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_email:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($httpResponse["EMAIL"]) .

'      </td>
      </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_telephone: </td>
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($PHONENUM) .

'      </td>
    </tr>
    <tr>
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left"></td>
    </tr>
   </tbody>
  </table>';
  
  return($table);
 }



function doexpress($TOKEN,$PAYERID,$pectransid)
	{

	if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );

		
			
					
		
	$jinput =JFactory::getApplication()->input;
	 
	$value='pectransid'; $order_data[$value] = $jinput->post->get($value, null, 'CMD');
	$value='token'; $order_data[$value] = $jinput->post->get($value, null, 'CMD');
	$value='PAYERID'; $order_data[$value] = $jinput->post->get($value, null, 'CMD');
	
	

if(!isset($order_data['token']))
	{
	$order_data['token'] = $TOKEN;
	}

if(!isset($order_data['PAYERID']))
	{
	$order_data['PAYERID'] = $PAYERID;
	}
  
  
if(!isset($order_data['pectransid']))
	{
	$order_data['pectransid'] = $pectransid;
	}
	
	
	if (!isset($order_data["pectransid"]))
	   {
	   return;
	   }
	
	
	
	$order_number = $order_data["pectransid"];
	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_data["pectransid"]);

	if (!$virtuemart_order_id)
	  {
	  return;
	  }


	$vendorId = 0;
	$payment = $this->getDataByOrderId($virtuemart_order_id);

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	if (!$this->selectedThisElement($method->payment_element)) {
	
	print 'no order id';
	    return false;
	}

if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
	    $modelOrder = new VirtueMartModelOrders();
	    
	    $order = $modelOrder->getOrder($virtuemart_order_id);




	

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$order_total=0;
$total_discount=0;
$total_tax=0;
$total_shipping=0;

$table='';

$customer_currency = 0;

	$customer_currency = trim($payment->alt_currency);


list($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems) = $this->order_form($order,$method,$customer_currency);



$address = $order['details']['BT'];

$del_address = null;
	
if(isset($order['details']['ST']))
   {
   $del_address = $order['details']['ST'];
   }
else
   {
   $del_address = $order['details']['BT'];
   }


$country = ShopFunctions::getCountryByID($address->virtuemart_country_id, "country_2_code");
$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";


$del_country = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, "country_2_code");
$del_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id) : "";

list($order_form,$order_form_html_billing,$order_form_html_shipping) = $this->billing_shipping_address($address,$del_address,$country,$del_country,$cc_state,$del_state);

$shop_code = $payment->currency_code;


if($method->ssc_multi_currency)
	{
	$customer_currency = trim($payment->alt_currency);
	$this->getPaymentCurrency($method);
	$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $customer_currency  . '" ';
	$db = JFactory::getDBO();
	$db->setQuery($q);
	$shop_code = $db->loadResult();
	}



$IPN =  $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component');

$APIrequest =
"&TOKEN=" . $order_data['token'] .
"&PAYMENTREQUEST_0_PAYMENTACTION=" . $method->ssc_payment_action .
"&PAYERID=" . $order_data['PAYERID'] .





"&PAYMENTREQUEST_0_CURRENCYCODE=" . $shop_code .
"&PAYMENTREQUEST_0_ITEMAMT=" . $line_order_total .
"&PAYMENTREQUEST_0_SHIPPINGAMT=" . $shipping .
"&PAYMENTREQUEST_0_TAXAMT=" . $total_tax .
"&PAYMENTREQUEST_0_AMT=" . $order_total .




$line_order_details .

"&PAYMENTREQUEST_0_NOTIFYURL=" . urlencode($IPN);

if($method->debug)
	{
	echo '<span style="color: ' . '#' . 'FF0000">';
	echo "<br/>You have enabled debugging in setup. Turn it off to remove the debug information below<br/>2<br/>";
	echo '<br>VMPATH_SITE - New -' . VMPATH_SITE . '<br>' . 'JPATH_VM_SITE - old -' . JPATH_VM_SITE . '<br>';
	echo '</span>';

	echo 'APIrequest:' . $APIrequest . '<BR>';
	}

$httpResponse = $this->PPHttpPost($method,"DoExpressCheckoutPayment", $APIrequest);


if("SUCCESS" == strtoupper($httpResponse["ACK"]) || "SUCCESSWITHWARNING" == strtoupper($httpResponse["ACK"]))
   {
   
$paypal_fullresponse = json_encode($httpResponse);

$db = JFactory::getDBO();

try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_paypalplusssc` SET `paypal_fullresponse` = '" . $paypal_fullresponse . "' WHERE `#__virtuemart_payment_plg_paypalplusssc`.`virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);
	$db->query($q);

	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}


if($method->ssc_show_thank_you)
	{
   print "<p style='font-size: x-large'>" . JText::_('VMPAYMENT_PPP_SSC_THANK_YOU_FOR_YOUR_ORDER') . "</p>";
	}
   
echo $method->ssc_receipt_header;
echo '<br/><br/>';
echo $table;
echo '<br/>';


if($method->ssc_show_receipt_address)
	{
	
$show_shipping=1;

print '<table style="width: 600px" cellspacing="0" cellpadding="2">';
print '<tr><td style="border-style:hidden" valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';


print '<br/><b>&nbsp;&nbsp;&nbsp;&nbsp;' . JText::_('VMPAYMENT_PPP_SSC_BILLING_ADDRESS')  . '</b><br/><br/>';
echo $order_form_html_billing;

print '</td><td style="border-style:hidden" valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';

if($show_shipping == 1)
	{
	print '<br/><b>&nbsp;' . JText::_('VMPAYMENT_PPP_SSC_SHIPPING_ADDRESS') . '</b><br/><br/>';
		echo $order_form_html_shipping;
	}

print '</td></tr></table>';
	
	}

$table = '<p style="font-size: small">';
	
$table .= '<table cellspacing="0" cellpadding="2">';
$table .= '<tr><td style="border-style:hidden">';
$table .= JText::_('VMPAYMENT_PPP_SSC_ORDER_NUMBER') . ':</td>';
$table .= '<td style="border-style:hidden">&nbsp;&nbsp;';
$table .= $order["details"]["BT"]->order_number;
$table .= '</td></tr>';
	
	
$table .= '</table>';
	
$table .= '</style>';

echo $table;

echo $method->ssc_receipt_footer;

echo $method->ssc_raw;




$new_status = "C";
	
	if (!class_exists("VirtueMartModelOrders"))
				require( JPATH_VM_ADMINISTRATOR . '/' . "models" . '/' . "orders.php" );

	$modelOrder = VmModel::getModel("orders");
	
	$orderitems = $modelOrder->getOrder($virtuemart_order_id);
	$nb_history = count($orderitems['history']);
	
	$orders["order_status"] = "C";
	$orders["virtuemart_order_id"] = $virtuemart_order_id;
	$orders["customer_notified"] = 1;
	$orders["comments"] = "";


       


	if ($orderitems['history'][$nb_history - 1]->order_status_code != $orders['order_status'])
		{
		$orders['comments'] .= "<br />" . JText::sprintf('VMPAYMENT_PPP_SSC_CONFIRMED_EMAIL_SENT');
		$orders['customer_notified'] = 1;	
		}
	else
		{
		$orders['customer_notified'] = 0;		
		}


	$orderitems = $modelOrder->getOrder($virtuemart_order_id);
	
	if(isset($orderitems['details']['BT']->order_status) && $orderitems['details']['BT']->order_status == 'S')
		{
				}
	else
		{
				$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $orders, true);	
		}
	

$html="";

$hidessc = "<style>
img#hidessc + h1
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + h3
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + div > h3:first-child
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<img id='hidessc'/>
";

echo $hidessc;




$this->emptyCart(null);

	
	






 
return;
   }
else
   {
   
    $return_button = "<script language='JavaScript'><!--\r\n" .
   "document.write('<br><br><input type=\"button\" value=\"Return\" name=\"b1\" onClick=\"history.go(-1)\">&nbsp;&nbsp;')" .           
   "\r\n--></script>";   
   
   $url = $this->https_check(JURI::root());
   
   $return_button =
   "<form action='$url'>
    <input type='submit' value='Return'>
	</form>";

   
   $s=0;
   $error ="No";
         print "<span style='font-family: Arial, Helvetica, sans-serif; font-size: large; color: #FF0000'>";
   while(isset($httpResponse["L_LONGMESSAGE" . $s]))
   {

   
   if($httpResponse["L_ERRORCODE" . $s] == "500")
      {
	  print JText::_('VMPAYMENT_PPP_SSC_UNKNOWN_ERROR');  
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "81234")
      {
      print "";        
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10525")
      {
	   print "Transaction already processed or Amount is zero";          }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10002" && $httpResponse["L_LONGMESSAGE" . $s] == 'Security%20header%20is%20not%20valid')
      {
      print "Please check your API Username, Password and Signature for your Live or Sandbox account.";	         
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10002" && $httpResponse["L_LONGMESSAGE" . $s] == 'You%20do%20not%20have%20permissions%20to%20make%20this%20API%20call')
      {
      print "Do you have a valid Payments Pro Live or Sandbox account with the correct API Username, Password and Signature";	         
      }  
   elseif($httpResponse["L_ERRORCODE" . $s] == "10415")
      {
      print JText::_('VMPAYMENT_PPP_SSC_TRANSACTION_ALREADY_COMPLETED') . ".";	         
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10001")
      {
      print JText::_('VMPAYMENT_PPP_SSC_SERVER_TAKING_TOO_LONG_TO_RESPOND');
      
         	         
      }
      
   else
      {
   
      if($error == 'No')
         {      
         print "<br>" . JText::_('VMPAYMENT_PPP_SSC_TRY_AGAIN') . "<br>";
         $error='Yes';
         
             
         }
         	         
      print $httpResponse["L_ERRORCODE" . $s] . ": " . urldecode($httpResponse["L_LONGMESSAGE" . $s]) . " <br><br>\r\n";  
      }
   $s++;
     
   }
    print $return_button;
  
    print "<br></span><br>";
}




$html="";



$hidessc = "<style>
img#hidessc + h1
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + h3
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + div > h3:first-child
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<img id='hidessc'/>
";

echo $hidessc;

		

    

    }

function order_form($order,$method,$customer_currency)
{

if (!class_exists('CurrencyDisplay'))
    require(JPATH_VM_ADMINISTRATOR . '/' . 'helpers' . '/' . 'currencydisplay.php');

$paymentCurrency = CurrencyDisplay::getInstance();

if (!class_exists ('VirtueMartCart'))
	{
	require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php');
	}




if(!isset($order['details']['BT']->virtuemart_paymentmethod_id))
	{
	
		$cart = VirtueMartCart::getCart ();
	$cart->prepareCartData(); 	$cart->getCartPrices();
	$db = JFactory::getDbo();
	$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalplusssc" AND `published` = 1';
	$db->setQuery($q);
	$virtuemart_paymentmethod_id = $db->loadResult();
	$cart->virtuemart_paymentmethod_id = $virtuemart_paymentmethod_id;
	$cart->setCartIntoSession();
	}
else
   {
   	$cart = VirtueMartCart::getCart ();
	$cart->prepareCartData(); 	$cart->getCartPrices();
	
					
		   
   }



if($method->debug)
	{
	echo '$method->ssc_multi_currency ' . $method->ssc_multi_currency . '<br>';
	echo '$customer_currency ' . $customer_currency . '<br>';
	echo '$method->payment_currency ' . $method->payment_currency . '<br>';
	}

$this->getPaymentCurrency($method);  
if($method->ssc_multi_currency)
	{
	$prices_currency = $customer_currency;
	}
else
	{
	$prices_currency = $method->payment_currency;
	}




if($method->debug)
	{
	echo '$method->payment_currency ' . $method->payment_currency . '<br>';
	echo '$prices_currency ' . $prices_currency . '<br>';	
	}
	
$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $prices_currency . '" ';
$db = JFactory::getDBO();
$db->setQuery($q);
$currency_code_3 = $db->loadResult();


$dp=2;

if($currency_code_3 == 'JPY')
	{
	$dp=0;
	}



$q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $prices_currency . '" ';

$db->setQuery($q);
$currency_symbol = $db->loadResult();

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$inc_tax = 0;




$unit_price = JText::_('VMPAYMENT_PPP_SSC_UNIT_PRICE');

$unit_price = str_replace(' ','&nbsp;',$unit_price);

$table = '<table border="1" width="600" cellspacing="0" cellpadding="2" class="ssc">
<tr>
	<td style="background-color: rgb(220,220,220)" width="50"><strong><font face="Arial"
	size="2">' . JText::_('VMPAYMENT_PPP_SSC_ID') . '&nbsp;&nbsp;</font></strong></td>
	<td style="background-color: rgb(220,220,220)" width="400"><strong><font face="Arial"
	size="2">' . JText::_('VMPAYMENT_PPP_SSC_ITEM') .  '</font></strong></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><font face="Arial"
	size="2"><strong>' . $unit_price .'&nbsp;</strong></font></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
	size="2">&nbsp;' . JText::_('VMPAYMENT_PPP_SSC_QUANTITY') . '&nbsp;</font></strong></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
	size="2">&nbsp;' . JText::_('VMPAYMENT_PPP_SSC_TOTALS') . '</font></strong></td>
</tr>';

    
$pppitems = array(); 

$i = 1;

foreach ($order["items"] as $key => $product)
	{
	$line_item_name = substr(strip_tags($product->order_item_name), 0, 127);
		     
	     
	$line_id = substr(strip_tags($product->order_item_sku), 0, 127);
		     
		$cost = $product->product_item_price;
		
	$cost = $paymentCurrency->convertCurrencyTo($prices_currency, $cost, false);
	$cost = number_format($cost,$dp,'.','');
	     
		     
		     
		     

     
		
	$qty = $product->product_quantity;
	     
	$line_fields = $product->product_attribute;
	

	
	if (!empty($product->product_attribute))
		{
		if(!class_exists('VirtueMartModelCustomfields'))require(JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'customfields.php');
		$line_fields = VirtueMartModelCustomfields::CustomsFieldOrderDisplay($product,'FE');
		}
	
	$strip_line_fields = strip_tags($line_fields);


	if($line_fields === '')
		{
	    $line_description = substr($line_id, 0, 127);
		}
	else
		{
		$line_description = substr($line_id . ' ' . $strip_line_fields, 0, 127);
		}
	     
	$n = $i-1;
	    
	$line_order_details .= 
	"&L_PAYMENTREQUEST_0_NAME" . "$n=" . urlencode($line_item_name) .
	"&L_PAYMENTREQUEST_0_NUMBER" . "$n=" . urlencode($line_description) .
	"&L_PAYMENTREQUEST_0_QTY" . "$n=" . $qty .  
	"&L_PAYMENTREQUEST_0_AMT" . "$n=" . $cost;
	
	
	$pppitem = new \PayPal\Api\Item();
	
	
	
	
    
	if(trim($line_description) == '')
		{
	
	$pppitem->setName($line_item_name)
    ->setCurrency($currency_code_3)
    ->setQuantity($qty)
    ->setPrice($cost);
   
		}
	else
		{
    
    $pppitem->setName($line_item_name)
    ->setCurrency($currency_code_3)
    ->setQuantity($qty)
    ->setSku($line_description)     ->setPrice($cost);
    
		}
    
    
    
    
    
	$pppitems[$n] = $pppitem;
		
    
	$line_order_total += $qty * $cost;
     
     
	$table = $table . '<tr>';    
   
	$table = $table . '<td valign="top">' . $line_id . "</td>"; 
     
	$table = $table . '<td valign="top">' . $line_item_name  . '&nbsp;' . $line_fields;   
     
	$table = $table . '</td>'; 
      
	$table = $table . '<td valign="top" align="right">' .  $currency_symbol . $cost . "</td>"; 
      
	$table = $table . '<td valign="top" align="right">' . $qty . "</td>"; 
      
	$table = $table . '<td valign="top" align="right">&nbsp;&nbsp;' .  $currency_symbol . number_format($qty * $cost,$dp,'.','') . '</td>'; 
  
   
  
	$table = $table . '</tr>';
    
	$i++;
	     
	} 	  
			

	  if(isset($order['details']['BT']->order_payment) && $order['details']['BT']->order_payment > 0)
	  	     {  
	     	     $order_payment = $order['details']['BT']->order_payment;
	     
         $order_payment = $paymentCurrency->convertCurrencyTo($prices_currency, $order_payment, false);
         
         $order_payment = number_format($order_payment,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $payment_fee = JText::_('VMPAYMENT_PPP_SSC_PAYMENT_FEE');
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=" . urlencode($payment_fee) .
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $order_payment;
         
         
         $pppitem = new \PayPal\Api\Item();
			$pppitem->setName($payment_fee)
				->setCurrency($currency_code_3)
				->setQuantity(1)	
				->setPrice($order_payment);
				
								
			$pppitems[$n] = $pppitem;
         
    
             
         $line_order_total = $line_order_total + $order_payment;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . $payment_fee . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . $currency_symbol . number_format($order_payment,$dp,'.','') . '</td></tr>';

	     }



$table = $table . '<tr>';
$table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPP_SSC_ITEM_TOTAL') . ':&nbsp;</td>';
$table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($line_order_total,$dp,'.','') . '</td></tr>';     
	     
	    
$line_order_total = round($line_order_total,$dp);

$shipping = 0;

	    
	if(isset($order['details']['BT']->order_shipment) && $order['details']['BT']->order_shipment > 0)
		{  
	   $shipping = $order['details']['BT']->order_shipment;
	    
	    $shipping = $paymentCurrency->convertCurrencyTo($prices_currency, $shipping, false);    
	    
	    $shipping = number_format($shipping,$dp,'.','');
	     	     
		$table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPP_SSC_SHIPPING') .':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($shipping,$dp,'.','') . '</td></tr>';
	    }


$total_tax = 0;



	if(isset($order['details']['BT']->order_billTaxAmount) && $order['details']['BT']->order_billTaxAmount > 0)
		     {
         $order_bill_tax = $order['details']['BT']->order_billTaxAmount;
                 
         $order_bill_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $order_bill_tax, false);
         
         if($order_bill_tax > $total_tax)
         	{
	     	$total_tax = $order_bill_tax;
	     		     	}
	     }


      if($total_tax > 0 || $shipping > 0)
       {
	    $total_tax = number_format($total_tax,$dp,'.','');
	    

	    $line_order_total2 = number_format($line_order_total,$dp,'.','');
		$shipping2 = number_format($shipping,$dp,'.','');
		$total_tax2 = number_format($total_tax,$dp,'.','');

		$order_total2 = $line_order_total2 + $shipping2 + $total_tax2;
		$order_total2 = number_format($order_total2,$dp,'.','');

		$cart_order_total2 = $order['details']['BT']->order_total;
				
		
		$cart_order_total2 = $paymentCurrency->convertCurrencyTo($prices_currency,$cart_order_total2,false); 
		$cart_order_total2 = number_format($cart_order_total2,$dp,'.','');

		if($order_total2 < $cart_order_total2)
			{  
			$total_discount2 = $cart_order_total2 - $order_total2;
	     
						$total_discount2 = number_format($total_discount2,$dp,'.','');
			    
	    		    		    		    		    	
	    		    		    		    		    		    		    		    	    					
			
			
	    	if($shipping > 0)
	    		{
	    		$shipping +=  $total_discount2;
	    	    		}
			elseif($total_tax > 0)
	    		{
	    		$total_tax += $total_discount2;
	    		}				

	    
	    	}




 
		$table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPP_SSC_TAX') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_tax,$dp,'.','') . '</td></tr>';


	     }
	     
	     
$total_discount = 0;




$line_order_total = number_format($line_order_total,$dp,'.','');
$shipping = number_format($shipping,$dp,'.','');
$total_tax = number_format($total_tax,$dp,'.','');

$order_total = $line_order_total + $shipping + $total_tax;
$order_total = number_format($order_total,$dp,'.','');


$cart_order_total = $order['details']['BT']->order_total;

$cart_order_total = $paymentCurrency->convertCurrencyTo($prices_currency,$cart_order_total,false); 
$cart_order_total = number_format($cart_order_total,$dp,'.','');

if($order_total > $cart_order_total)
	     {  
	     $total_discount = $cart_order_total - $order_total;
	     
	     $order_total = $cart_order_total;
	     
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=Discount" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=Discount" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $total_discount;
         
         
         $pppitem = new \PayPal\Api\Item();
			$pppitem->setName('Discount')
				->setCurrency($currency_code_3)
				->setQuantity(1)
				->setSku('Discount') 				->setPrice($total_discount);
				
			$pppitems[$n] = $pppitem;

    
             
         $line_order_total = $line_order_total + $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPP_SSC_DISCOUNT') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }


if($order_total < $cart_order_total)
	     {  
	     $total_discount = $cart_order_total - $order_total;
	     
	     $order_total = $cart_order_total;
	     
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $surcharge = urlencode(JText::_('VMPAYMENT_PPP_SSC_SURCHARGE'));
	     $surcharge = 'sur';
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=$surcharge" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=$surcharge" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $total_discount;
         
         $pppitem = new \PayPal\Api\Item();
         
			$pppitem->setName($surcharge)
				->setCurrency($currency_code_3)
				->setQuantity(1)
				->setPrice($total_discount);
				
							
			$pppitems[$n] = $pppitem;

    
             
         $line_order_total = $line_order_total + $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPP_SSC_SURCHARGE') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }





	    $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPP_SSC_ORDER_TOTAL') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($order_total,$dp,'.','') . '</td></tr>';

 $table .= '</table>';

  $table .= '<p style="font-size: small">';
	
	$table .= '<table cellspacing="0" cellpadding="2">';
						
	$table .= '<tr><td style="border-style:hidden; text-align: right;">';
	$table .= JText::_('VMPAYMENT_PPP_SSC_CURRENCY') . ':</td><td style="border-style:hidden">&nbsp;&nbsp;';
	$table .= $currency_code_3;
	$table .= '</td></tr>';
	
	$table .= '</table>';
	
	$table .= '</style>';

if($method->debug)
	{
	echo '<span style="color: ' . '#' . 'FF0000">';
	echo "<br/>You have enabled debugging in setup. Turn it off to remove the debug information below<br/>3<br/>";
	echo '</span>';


echo '<br><br>';
echo $_SERVER["SERVER_PORT"] .'<br>';
echo $_SERVER["SERVER_NAME"] .'<br>';
echo $_SERVER["REQUEST_URI"] .'<br>';

if(isset($_SERVER["HTTPS"]))
	{
	echo $_SERVER["HTTPS"]  . '<br>';
	}
else
	{
	echo'No<br>';
	}

echo 'JURI root: ' . JURI::root()  . '<br>';
}

return array($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems);

}





function process_success($paymentId,$PayerID,$pectransid)
	{

	if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );

		
	
		

$order_data = $this->post_strings();
$order_get = $this->get_strings();	
		



			
					
		
	
		
		$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($pectransid);

	if (!$virtuemart_order_id)
	  {
	  return;
	  }


	$vendorId = 0;
	$payment = $this->getDataByOrderId($virtuemart_order_id);

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	if (!$this->selectedThisElement($method->payment_element)) {
	
	print 'no order id for ppp';
	    return false;
	}
	

$hidessc = "<style>
img#hidessc + h1
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + h3
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + div > h3:first-child
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<img id='hidessc'/>
";

	

if($this->_rest == true)
{


$ssc1 = $method->ssc_ssc1;
$ssc2 = $method->ssc_ssc2;


$apiContext = new \PayPal\Rest\ApiContext
	(
	new \PayPal\Auth\OAuthTokenCredential
		(
		$ssc1,  
		$ssc2
		)
	);




$m = "LIVE";

if($method->ssc_environment == "sandbox")
   {
   $m = "SANDBOX";
   }


$apiContext->setConfig(
    array('mode' => $m)
); 



$payment = null;



try
	{
	$payment = \PayPal\Api\Payment::get($paymentId, $apiContext);
	}
catch (Exception $ex)
	{

	echo '<br>' . JText::_('VMPAYMENT_PPP_SSC_CONNECTING_TO_PAYPAL') . '<br/><br/>';
	
	echo '<button onclick="location.reload();">' . JText::_('VMPAYMENT_PPP_SSC_CLICK') . '</button>';
	
	
	if(!$method->debug)
   	{
   	print '<script type="text/javascript">';
   	print 'setTimeout(function(){location.reload();}, 2500);';
   	print '</script>';
   	}
        else
        {
        echo $ex;
        }


	echo $hidessc;

	return;
	}


$execution = new \PayPal\Api\PaymentExecution();
$execution->setPayerId($PayerID);



if($payment->getState() == 'approved')
	{
	echo 'This payment has already been processed<br/><br/>';
		}
else
	{
	try
		{
		$result = $payment->execute($execution, $apiContext);
				}
	catch (Exception $ex)
		{
		echo '<br>' . JText::_('VMPAYMENT_PPP_SSC_CONNECTING_TO_PAYPAL') . '<br/><br/>';
	
		echo '<button onclick="location.reload();">' . JText::_('VMPAYMENT_PPP_SSC_CLICK') . '</button>';
	
	
		if(!$method->debug)
   		{
   		print '<script type="text/javascript">';
   		print 'setTimeout(function(){location.reload();}, 2500);';
   		print '</script>';
   		}
            else
                {
                echo $ex;
                }
	
		echo $hidessc;

		return;
		}

	}
	
}	



	

if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
	    $modelOrder = new VirtueMartModelOrders();
	    
	    $order = $modelOrder->getOrder($virtuemart_order_id);




	

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$order_total=0;
$total_discount=0;
$total_tax=0;
$total_shipping=0;

$table='';

$customer_currency = 0;

	$customer_currency = trim($payment->alt_currency);


list($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems) = $this->order_form($order,$method,$customer_currency);



$address = $order['details']['BT'];

$del_address = null;
	
if(isset($order['details']['ST']))
   {
   $del_address = $order['details']['ST'];
   }
else
   {
   $del_address = $order['details']['BT'];
   }


$country = ShopFunctions::getCountryByID($address->virtuemart_country_id, "country_2_code");
$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";


$del_country = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, "country_2_code");
$del_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id) : "";

list($order_form,$order_form_html_billing,$order_form_html_shipping) = $this->billing_shipping_address($address,$del_address,$country,$del_country,$cc_state,$del_state);

$shop_code = $payment->currency_code;


if($method->ssc_multi_currency)
	{
	$customer_currency = trim($payment->alt_currency);
	$this->getPaymentCurrency($method);
	$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $customer_currency  . '" ';
	$db = JFactory::getDBO();
	$db->setQuery($q);
	$shop_code = $db->loadResult();
	}



$httpResponse = null;
   




$transactions = $payment->getTransactions();

$transaction = $transactions[0];

$payer = $payment->getPayer();


$httpResponse =  new StdClass;

$httpResponse->total = $transaction->amount->total;
$httpResponse->currency = $transaction->amount->currency;

$httpResponse->subtotal = $transaction->amount->details->subtotal;
$httpResponse->tax = $transaction->amount->details->tax;
$httpResponse->shipping = $transaction->amount->details->shipping;


$httpResponse->merchant_id = $transaction->payee->merchant_id;

$httpResponse->description = $transaction->description;
$httpResponse->invoice_number = $transaction->invoice_number;

$httpResponse->shipping_recipient_name   = $transaction->item_list->shipping_address->recipient_name;
$httpResponse->shipping_line1   = $transaction->item_list->shipping_address->line1;
$httpResponse->shipping_city   = $transaction->item_list->shipping_address->city;
$httpResponse->shipping_state   = $transaction->item_list->shipping_address->state;
$httpResponse->shipping_postal_code = $transaction->item_list->shipping_address->postal_code;
$httpResponse->shipping_country_code   = $transaction->item_list->shipping_address->country_code;

$httpResponse->id = $transaction->related_resources[0]->sale->id;
$httpResponse->state = $transaction->related_resources[0]->sale->state;


$httpResponse->payment_mode = $transaction->related_resources[0]->sale->payment_mode;

$httpResponse->protection_eligibility  = $transaction->related_resources[0]->sale->protection_eligibility;
$httpResponse->protection_eligibility_type = $transaction->related_resources[0]->sale->protection_eligibility_type;


$httpResponse->parent_payment = $transaction->related_resources[0]->sale->parent_payment;


$httpResponse->create_time = $transaction->related_resources[0]->sale->create_time;
$httpResponse->update_time = $transaction->related_resources[0]->sale->update_time;

$httpResponse->payment_method = $payer->payment_method;
$httpResponse->payer_status = $payer->status;


$httpResponse->email = $payer->payer_info->email;
$httpResponse->first_name = $payer->payer_info->first_name;
$httpResponse->last_name = $payer->payer_info->last_name;
$httpResponse->payer_id = $payer->payer_info->payer_id;
$httpResponse->phone = $payer->payer_info->phone;
$httpResponse->country_code = $payer->payer_info->country_code;



$paypal_fullresponse = json_encode($httpResponse);

$db = JFactory::getDBO();

try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_paypalplusssc` SET `paypal_fullresponse` = '" . $paypal_fullresponse . "' WHERE `#__virtuemart_payment_plg_paypalplusssc`.`virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);
	$db->query($q);

	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}

	
	


if($method->ssc_show_thank_you)
	{
   print "<p style='font-size: x-large'>" . JText::_('VMPAYMENT_PPP_SSC_THANK_YOU_FOR_YOUR_ORDER') . "</p>";
	}
   
echo $method->ssc_receipt_header;
echo '<br/><br/>';
echo $table;
echo '<br/>';


if($method->ssc_show_receipt_address)
	{
	
$show_shipping=1;

print '<table style="width: 600px" cellspacing="0" cellpadding="2">';
print '<tr><td style="border-style:hidden" valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';


print '<br/><b>&nbsp;&nbsp;&nbsp;&nbsp;' . JText::_('VMPAYMENT_PPP_SSC_BILLING_ADDRESS')  . '</b><br/><br/>';
echo $order_form_html_billing;

print '</td><td style="border-style:hidden" valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';

if($show_shipping == 1)
	{
	print '<br/><b>&nbsp;' . JText::_('VMPAYMENT_PPP_SSC_SHIPPING_ADDRESS') . '</b><br/><br/>';
		echo $order_form_html_shipping;
	}

print '</td></tr></table>';
	
	}

$table = '<p style="font-size: small">';
	
$table .= '<table cellspacing="0" cellpadding="2">';
$table .= '<tr><td style="border-style:hidden">';
$table .= JText::_('VMPAYMENT_PPP_SSC_ORDER_NUMBER') . ':</td>';
$table .= '<td style="border-style:hidden">&nbsp;&nbsp;';
$table .= $order["details"]["BT"]->order_number;
$table .= '</td></tr>';
	
	
$table .= '</table>';
	
$table .= '</style>';

echo $table;

echo $method->ssc_receipt_footer;

echo $method->ssc_raw;




$new_status = "C";
	
	if (!class_exists("VirtueMartModelOrders"))
				require( JPATH_VM_ADMINISTRATOR . '/' . "models" . '/' . "orders.php" );

	$modelOrder = VmModel::getModel("orders");
	
	$orderitems = $modelOrder->getOrder($virtuemart_order_id);
	$nb_history = count($orderitems['history']);
	
	$orders["order_status"] = "C";
	$orders["virtuemart_order_id"] = $virtuemart_order_id;
	$orders["customer_notified"] = 1;
	$orders["comments"] = "";


       


	if ($orderitems['history'][$nb_history - 1]->order_status_code != $orders['order_status'])
		{
		$orders['comments'] .= "<br />" . JText::sprintf('VMPAYMENT_PPP_SSC_CONFIRMED_EMAIL_SENT');
		$orders['customer_notified'] = 1;	
		}
	else
		{
		$orders['customer_notified'] = 0;		
		}


	$orderitems = $modelOrder->getOrder($virtuemart_order_id);
	
	if(isset($orderitems['details']['BT']->order_status) && $orderitems['details']['BT']->order_status == 'S')
		{
				}
	else
		{
				$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $orders, true);	
		}
	

$html="";

echo $hidessc;



$this->emptyCart(null);

	
	






 
return;
   
}





function order_form_cart($order,$method,$customer_currency)
{

if (!class_exists('CurrencyDisplay'))
    require(JPATH_VM_ADMINISTRATOR . '/' . 'helpers' . '/' . 'currencydisplay.php');

$paymentCurrency = CurrencyDisplay::getInstance();

if (!class_exists ('VirtueMartCart'))
	{
	require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php');
	}




   




$cart = VirtueMartCart::getCart ();
$cart->prepareCartData(); $cart->getCartPrices();





  



if($method->debug)
	{
	echo '$method->ssc_multi_currency ' . $method->ssc_multi_currency . '<br>';
	echo '$customer_currency ' . $customer_currency . '<br>';
	echo '$method->payment_currency ' . $method->payment_currency . '<br>';
	}

$this->getPaymentCurrency($method);  
if($method->ssc_multi_currency)
	{
	$prices_currency = $customer_currency;
	}
else
	{
	$prices_currency = $method->payment_currency;
	}




if($method->debug)
	{
	echo '$method->payment_currency ' . $method->payment_currency . '<br>';
	echo '$prices_currency ' . $prices_currency . '<br>';	
	}
	
$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $prices_currency . '" ';
$db = JFactory::getDBO();
$db->setQuery($q);
$currency_code_3 = $db->loadResult();


$dp=2;

if($currency_code_3 == 'JPY')
	{
	$dp=0;
	}



$q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $prices_currency . '" ';

$db->setQuery($q);
$currency_symbol = $db->loadResult();

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$inc_tax = 0;




$unit_price = JText::_('VMPAYMENT_PPP_SSC_UNIT_PRICE');

$unit_price = str_replace(' ','&nbsp;',$unit_price);

$table = '<table border="1" width="600" cellspacing="0" cellpadding="2" class="ssc">
<tr>
	<td style="background-color: rgb(220,220,220)" width="50"><strong><font face="Arial"
	size="2">' . JText::_('VMPAYMENT_PPP_SSC_ID') . '&nbsp;&nbsp;</font></strong></td>
	<td style="background-color: rgb(220,220,220)" width="400"><strong><font face="Arial"
	size="2">' . JText::_('VMPAYMENT_PPP_SSC_ITEM') .  '</font></strong></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><font face="Arial"
	size="2"><strong>' . $unit_price .'&nbsp;</strong></font></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
	size="2">&nbsp;' . JText::_('VMPAYMENT_PPP_SSC_QUANTITY') . '&nbsp;</font></strong></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
	size="2">&nbsp;' . JText::_('VMPAYMENT_PPP_SSC_TOTALS') . '</font></strong></td>
</tr>';

   $pppitems = array();
$i = 1;

foreach ($cart->products as $key => $product)
	{
		$line_item_name = substr(strip_tags($product->product_name), 0, 127);
	     
	     
		$line_id = substr(strip_tags($product->product_sku), 0, 127);
	     
			$cost = $cart->pricesUnformatted[$key]["basePrice"];
	
	$cost = $paymentCurrency->convertCurrencyTo($prices_currency, $cost, false);
	$cost = number_format($cost,$dp,'.','');
	     
		     
		     
		     

     
	$qty = $product->quantity;
	
		     
		$line_fields = '';

	
	if (!empty($product->product_attribute))
		{
		if(!class_exists('VirtueMartModelCustomfields'))require(JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'customfields.php');
		$line_fields = VirtueMartModelCustomfields::CustomsFieldOrderDisplay($product,'FE');
		}
	
	$strip_line_fields = strip_tags($line_fields);


	if($line_fields === '')
		{
	    $line_description = substr($line_id, 0, 127);
		}
	else
		{
		$line_description = substr($line_id . ' ' . $strip_line_fields, 0, 127);
		}
	     
	$n = $i-1;
	    
	$line_order_details .= 
	"&L_PAYMENTREQUEST_0_NAME" . "$n=" . urlencode($line_item_name) .
	"&L_PAYMENTREQUEST_0_NUMBER" . "$n=" . urlencode($line_description) .
	"&L_PAYMENTREQUEST_0_QTY" . "$n=" . $qty .  
	"&L_PAYMENTREQUEST_0_AMT" . "$n=" . $cost;
	
	
         
   $pppitem = new \PayPal\Api\Item();
   
   
   
   
	               
	if(trim($line_description) == '')
		{
	
	$pppitem->setName($line_item_name)
    ->setCurrency($currency_code_3)
    ->setQuantity($qty)
    ->setPrice($cost);
   
		}
	else
		{
    
    $pppitem->setName($line_item_name)
    ->setCurrency($currency_code_3)
    ->setQuantity($qty)
    ->setSku($line_description)     ->setPrice($cost);
    
		}

    
    
    
    
    
    
    
    
	$pppitems[$n] = $pppitem;

	
    
	$line_order_total += $qty * $cost;
     
     
	$table = $table . '<tr>';    
   
	$table = $table . '<td valign="top">' . $line_id . "</td>"; 
     
	$table = $table . '<td valign="top">' . $line_item_name  . '&nbsp;' . $line_fields;   
     
	$table = $table . '</td>'; 
      
	$table = $table . '<td valign="top" align="right">' .  $currency_symbol . $cost . "</td>"; 
      
	$table = $table . '<td valign="top" align="right">' . $qty . "</td>"; 
      
	$table = $table . '<td valign="top" align="right">&nbsp;&nbsp;' .  $currency_symbol . number_format($qty * $cost,$dp,'.','') . '</td>'; 
  
   
  
	$table = $table . '</tr>';
    
	$i++;
	     
	} 	  
			

	  	  if(isset($cart->pricesUnformatted["paymentValue"]) && $cart->pricesUnformatted["paymentValue"] > 0)
	     {  
	     $order_payment = $cart->pricesUnformatted["paymentValue"];
	     	     
         $order_payment = $paymentCurrency->convertCurrencyTo($prices_currency, $order_payment, false);
         
         $order_payment = number_format($order_payment,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $payment_fee = JText::_('VMPAYMENT_PPP_SSC_PAYMENT_FEE');
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=" . urlencode($payment_fee) .
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $order_payment;
         
         

			$pppitem = new \PayPal\Api\Item();
			$pppitem->setName($payment_fee)
				->setCurrency($currency_code_3)
				->setQuantity(1)
				->setPrice($order_payment);
				
							
			$pppitems[$n] = $pppitem;

         
    
             
         $line_order_total = $line_order_total + $order_payment;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . $payment_fee . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . $currency_symbol . number_format($order_payment,$dp,'.','') . '</td></tr>';

	     }



$table = $table . '<tr>';
$table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPP_SSC_ITEM_TOTAL') . ':&nbsp;</td>';
$table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($line_order_total,$dp,'.','') . '</td></tr>';     
	     
	    
$line_order_total = round($line_order_total,$dp);

$shipping = 0;

	if(isset($cart->pricesUnformatted["shipmentValue"]) && $cart->pricesUnformatted["shipmentValue"] > 0)
		{  
    $shipping = $cart->pricesUnformatted["shipmentValue"];
	    
	    
	    $shipping = $paymentCurrency->convertCurrencyTo($prices_currency, $shipping, false);    
	    
	    $shipping = number_format($shipping,$dp,'.','');
	     	     
		$table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPP_SSC_SHIPPING') .':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($shipping,$dp,'.','') . '</td></tr>';
	    }


$total_tax = 0;



		if(isset($cart->pricesUnformatted["billTaxAmount"]) && $cart->pricesUnformatted["billTaxAmount"] > 0)
	     {
                  $order_bill_tax = $cart->pricesUnformatted["billTaxAmount"];
        
         $order_bill_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $order_bill_tax, false);
         
         if($order_bill_tax > $total_tax)
         	{
	     	$total_tax = $order_bill_tax;
	     		     	}
	     }


      if($total_tax > 0 || $shipping > 0)
       {
	    $total_tax = number_format($total_tax,$dp,'.','');
	    

	    $line_order_total2 = number_format($line_order_total,$dp,'.','');
		$shipping2 = number_format($shipping,$dp,'.','');
		$total_tax2 = number_format($total_tax,$dp,'.','');

		$order_total2 = $line_order_total2 + $shipping2 + $total_tax2;
		$order_total2 = number_format($order_total2,$dp,'.','');

				$cart_order_total2 = $cart->pricesUnformatted["billTotal"];
		
		
		$cart_order_total2 = $paymentCurrency->convertCurrencyTo($prices_currency,$cart_order_total2,false); 
		$cart_order_total2 = number_format($cart_order_total2,$dp,'.','');

		if($order_total2 < $cart_order_total2)
			{  
			$total_discount2 = $cart_order_total2 - $order_total2;
	     
						$total_discount2 = number_format($total_discount2,$dp,'.','');
			    
	    		    		    		    		    	
	    		    		    		    		    		    		    		    	    				
			
			if($shipping > 0)
	    		{
	    		$shipping +=  $total_discount2;
	    	    		}
			elseif($total_tax > 0)
	    		{
	    		$total_tax += $total_discount2;
	    		}

	    
	    	}




 
		$table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPP_SSC_TAX') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_tax,$dp,'.','') . '</td></tr>';


	     }
	     
	     
$total_discount = 0;




$line_order_total = number_format($line_order_total,$dp,'.','');
$shipping = number_format($shipping,$dp,'.','');
$total_tax = number_format($total_tax,$dp,'.','');

$order_total = $line_order_total + $shipping + $total_tax;
$order_total = number_format($order_total,$dp,'.','');


$cart_order_total = $cart->pricesUnformatted["billTotal"];

$cart_order_total = $paymentCurrency->convertCurrencyTo($prices_currency,$cart_order_total,false); 
$cart_order_total = number_format($cart_order_total,$dp,'.','');

if($order_total > $cart_order_total)
	     {  
	     $total_discount = $cart_order_total - $order_total;
	     
	     $order_total = $cart_order_total;
	     
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=Discount" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=Discount" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $total_discount;
    
         
         $pppitem = new \PayPal\Api\Item();
			$pppitem->setName('Discount')
				->setCurrency($currency_code_3)
				->setQuantity(1)
				->setSku('Discount') 				->setPrice($total_discount);
				
			$pppitems[$n] = $pppitem;
         
    
             
         $line_order_total = $line_order_total + $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPP_SSC_DISCOUNT') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }


if($order_total < $cart_order_total)
	     {  
	     $total_discount = $cart_order_total - $order_total;
	     
	     $order_total = $cart_order_total;
	     
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $surcharge = urlencode(JText::_('VMPAYMENT_PPP_SSC_SURCHARGE'));
	     $surcharge = 'sur';
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=$surcharge" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=$surcharge" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $total_discount;
    
                  
            
         $pppitem = new \PayPal\Api\Item();
			$pppitem->setName($surcharge)
				->setCurrency($currency_code_3)
				->setQuantity(1)
				->setPrice($total_discount)
				
			->setSku($surcharge); 				
				
			$pppitems[$n] = $pppitem;
         
         
          $line_order_total = $line_order_total + $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPP_SSC_SURCHARGE') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }





	    $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPP_SSC_ORDER_TOTAL') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($order_total,$dp,'.','') . '</td></tr>';

 $table .= '</table>';

  $table .= '<p style="font-size: small">';
	
	$table .= '<table cellspacing="0" cellpadding="2">';
						
	$table .= '<tr><td style="border-style:hidden; text-align: right;">';
	$table .= JText::_('VMPAYMENT_PPP_SSC_CURRENCY') . ':</td><td style="border-style:hidden">&nbsp;&nbsp;';
	$table .= $currency_code_3;
	$table .= '</td></tr>';
	
	$table .= '</table>';
	
	$table .= '</style>';

if($method->debug)
	{
	echo '<span style="color: ' . '#' . 'FF0000">';
	echo "<br/>You have enabled debugging in setup. Turn it off to remove the debug information below<br/>4<br/>";
	echo '</span>';


echo '<br><br>';
echo $_SERVER["SERVER_PORT"] .'<br>';
echo $_SERVER["SERVER_NAME"] .'<br>';
echo $_SERVER["REQUEST_URI"] .'<br>';

if(isset($_SERVER["HTTPS"]))
	{
	echo $_SERVER["HTTPS"]  . '<br>';
	}
else
	{
	echo'No<br>';
	}

echo 'JURI root: ' . JURI::root()  . '<br>';
}

return array($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems);

}



function ssc_check()
	{
	$ssc = 1;
	if(!class_exists('ComposerAutoloaderInitSSC')) 
		require __DIR__  . '/fields/paypal/autoload.php';
    
	return $ssc;
	}



function https_check($url)
	{
				
	if(isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] === 'on')
		{
				$url = preg_replace("/^http:/", "https:", $url);
		}
		
	return $url;

	}




function _getTablepkeyValue($virtuemart_order_id) {
	$db = JFactory::getDBO();
	$q = 'SELECT ' . $this->_tablepkey . ' FROM `' . $this->_tablename . '` '
		. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
	$db->setQuery($q);

	if (!($pkey = $db->loadResult())) {
	    	    JFactory::getApplication()->enqueueMessage($db->getErrorMsg());
	    return '';
	}
	return $pkey;
    }

    /**
     * Display stored payment data for an order
     * @see components/com_virtuemart/helpers/vmPSPlugin::plgVmOnShowOrderBEPayment()
     */
    function plgVmOnShowOrderBEPayment($virtuemart_order_id, $payment_method_id) {

	if (!$this->selectedThisByMethodId($payment_method_id)) {
	    return null; 	}
	
	if (!($method = $this->getVmPluginMethod ($payment_method_id))) { 			return NULL; 		}


	$db = JFactory::getDBO();
	$q = 'SELECT * FROM `' . $this->_tablename . '` '
		. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
	$db->setQuery($q);
	if (!($paymentTable = $db->loadObject())) {
	    	    return '';
	}
	$this->getPaymentCurrency($paymentTable);
	$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $paymentTable->payment_currency . '" ';
	$db = JFactory::getDBO();
	$db->setQuery($q);
	$currency_code_3 = $db->loadResult();
	$html = '<table class="adminlist">' . "\n";
	$html .=$this->getHtmlHeaderBE();
	$html .= $this->getHtmlRowBE('Payment Method', $paymentTable->payment_name);
								
	
if ($paymentTable->paypal_fullresponse)
	{
		
	$response_data = json_decode($paymentTable->paypal_fullresponse);

	if($response_data)
		{	
		
		$html .= $this->getHtmlRowBE('Payer ID',$response_data->payer_id);
		$html .= $this->getHtmlRowBE('Customer Status',urldecode($response_data->payer_status));
		
		
		$html .= $this->getHtmlRowBE('Transaction ID',$response_data->id);
		$html .= $this->getHtmlRowBE('Order Time',urldecode($response_data->create_time));
	
		$html .= $this->getHtmlRowBE('Sub Total:',urldecode($response_data->subtotal));
		$html .= $this->getHtmlRowBE('Shipping:',urldecode($response_data->shipping));
		$html .= $this->getHtmlRowBE('Sales Tax:',urldecode($response_data->tax));
		$html .= $this->getHtmlRowBE('Order Total:',urldecode($response_data->total));
		$html .= $this->getHtmlRowBE('Currency:',$response_data->currency);
		$html .= $this->getHtmlRowBE('Payment Status:',$response_data->state);
	
		$html .= $this->getHtmlRowBE('Protection Eligibility:',$response_data->protection_eligibility);
		$html .= $this->getHtmlRowBE('Ptotection Type:',urldecode($response_data->protection_eligibility_type));
		
		
		
		$html .= '</table><br/>';
	
		$html .= "<script type=\"text/javascript\">
			function open_text() {
			document.getElementById('link').innerHTML = \"<b><a href='javascript:close_text()'>Hide PayPal Data</a><br/></b><br/>";
        
		foreach ($response_data as $key => $value)
			{
			$html .= ' <b>' . $key . '</b>:&nbsp;' . $value . '<br />';
			}

        
		$html .="\";
			}
		function close_text()
			{
			document.getElementById('link').innerHTML = \"<b><a href='javascript:open_text()'>Show PayPal Data</a></b>\";
			}
		</script>
		
		<div id='link'><b><a href='javascript:open_text()'>Show PayPal Data</a></b></div>";
		}
	else
		{
		$html .= '</table>';
		}
	
	}
	
	
	
	return $html;
    }

     

    /**
     * Check if the payment conditions are fulfilled for this payment method
     * @author: Valerie Isaksen
     *
     * @param $cart_prices: cart prices
     * @param $payment
     * @return true: if the conditions are fulfilled, false otherwise
     *
     */
   


		protected function checkConditions ($cart, $method, $cart_prices) {

		$this->convert ($method);
		
		$cat_cond = true;
		
		
		if( !empty($method->categories) or !empty($method->blocking_categories) ){
			if(!empty($method->categories)) $cat_cond = false;
									if(!is_array($method->categories)) $method->categories = array($method->categories);
			if(!is_array($method->blocking_categories)) $method->blocking_categories = array($method->blocking_categories);

			$msg = 'None of the products is in a category of the method '. $method->{$this->_psType.'_name'} . '<br>';
			
						foreach($cart->products as $product)
				{
				if(array_intersect($product->categories,$method->categories)){
										$cat_cond = true;
									}
				
				if(array_intersect($product->categories,$method->blocking_categories)){
					$cat_cond = false;
										$msg = 'At least one of the products is in a category which blockes the method '.$method->{$this->_psType.'_name'};
					break;
				}
			}
									
						
			if(!$cat_cond) {
								return false;
			}
		}

				
				
		$address = $cart->getST();
		

		$amount = $cart_prices['salesPrice'];
		$amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
			OR
			($method->min_amount <= $amount AND ($method->max_amount == 0)));

		$countries = array();
		if (!empty($method->countries)) {
			if (!is_array ($method->countries)) {
				$countries[0] = $method->countries;
			} else {
				$countries = $method->countries;
			}
		}
				if (!is_array ($address)) {
			$address = array();
			$address['virtuemart_country_id'] = 0;
		}

		if (!isset($address['virtuemart_country_id'])) {
			$address['virtuemart_country_id'] = 0;
		}
		if (in_array ($address['virtuemart_country_id'], $countries) || count ($countries) == 0) {
			if ($amount_cond) {
				return TRUE;
			}
		}

		return FALSE;
	}

	/**
	 * @param $method
	 */
	function convert ($method) {

		$method->min_amount = (float)$method->min_amount;
		$method->max_amount = (float)$method->max_amount;
		
					}


	/**
	 * @param $virtuemart_paymentmethod_id
	 * @param $paymentCurrencyId
	 * @return bool|null
	 */
	 
function plgVmgetEmailCurrency ($virtuemart_paymentmethod_id, $virtuemart_order_id, &$emailCurrencyId)
	{
	
	if (!($method = $this->getVmPluginMethod ($virtuemart_paymentmethod_id)))
		{
			return NULL; 		}
		if (!$this->selectedThisElement ($method->payment_element)) {
			return FALSE;
		}
		
		
		
	
	
	if(!$virtuemart_order_id)
	  {
	  return;
	  }

	$vendorId = 0;
	$payment = $this->getDataByOrderId($virtuemart_order_id);

			
					
				    
					
										
$emailCurrencyId = $payment->payment_currency;	





}

  function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {

	return $this->onStoreInstallPluginTable($jplugin_id);
    }



function plgVmOnCheckoutAdvertise($cart, &$payment_advertise)
	{
	
	$ver = VmConfig::getInstalledVersion();

	if (version_compare ($ver, '3.2.0', '>='))
		{
		return null;
		}
	
	
	$template = JFactory::getApplication()->getTemplate();	
		
		if(!$template == 'yootheme')
			{
			return null;	
			}
	
	
	if ($this->getPluginMethods($cart->vendorId) === 0)
		{
				return FALSE;
		}
	
	if ($cart->pricesUnformatted['salesPrice'] <= 0.0)
		{
				return NULL;
		}
		
	if (!($this->_currentMethod = $this->getVmPluginMethod($cart->virtuemart_paymentmethod_id)))
		{
				return NULL;
		}


	$html='';	
	$debug=0;

	$db = JFactory::getDbo();
	$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalplusssc" AND `published` = 1';
	$db->setQuery($q);
	$virtuemart_paymentmethod_id = $db->loadResult();
	
	if(empty($virtuemart_paymentmethod_id))
		{
		if($debug == 1)
			{
			$text = 'PayPal Express is not published';
			return $text;
			}
		return null;	
		}
		
	if($cart->virtuemart_paymentmethod_id > 0 && $cart->virtuemart_paymentmethod_id != $virtuemart_paymentmethod_id)		{ 
		if($debug) echo 'another payment processor is selected<br>';
		return null;
		}	
	
	$method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);
	
	


if($debug)
{

if($cart->_dataValidated)
	{
	echo 'dataValidated = 1<br>';
	}
else
	{
	echo 'dataValidated = 0<br>';
	}

if($cart->_confirmDone)
	{
	echo 'confirmDone = 1<br>';
	}
else
	{
	echo 'confirmDone = 0<br>';
	}

if($cart->_inConfirm)
	{
	echo 'inConfirm = 1<br>';
	}
else
	{
	echo 'inConfirm = 0<br>';
	}

if($cart->_fromCart)
	{
	echo 'fromCart = 1<br>';
	}
else
	{
	echo 'fromCart = 0<br>';
	}

if($cart->getInCheckOut())
	{
	echo 'inCheckout =1 <br>';
	}
else
	{
	echo 'inCheckout = 0<br>';
	}




print '<br>';


print '<br>';

echo "Current Method: " . $cart->virtuemart_paymentmethod_id . '<br/>';


}

$url = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&ecoplus=1&adv=yes');
	
$ReturnURL = '<a href="' . $url . '">' .
'<img style="border:0;margin-right:7px;" src="https://fpdbs.paypal.com/dynamicimageweb?cmd=_dynamic-image" alt="PayPal" align="left"></a>';

$payment_advertise[] = '';

$session = JFactory::getSession();

$new_price = 0;


if($debug)
	{
	print '<br>';
	print 'New Price: ' . $new_price . '<br>';
	print 'SSC Total: ' . $session->get('session_ssc_total') . '<br>';
	print 'Bill Total: ' . $cart->pricesUnformatted["billTotal"] . '<br>';
	print 'ssc_checkout=' . $this->get_cookie('ssc_checkout');
	}




if($session->get('session_ssc_total') != $cart->pricesUnformatted["billTotal"])
	{
	
	if($session->get('session_ssc_total') != null)
		{
		$new_price = 1;
		$application = JFactory::getApplication();

				$new_total = $cart->pricesUnformatted["billTotal"];
	
		$new_total = number_format($new_total,2,'.','');
		
		$this->getPaymentCurrency($method);
		
		$q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$currency_symbol = $db->loadResult();
			
		$new_message = JText::_('VMPAYMENT_PPP_SSC_ORDER_TOTAL') . ' : ' . $currency_symbol . $new_total;
		
		if($cart->_dataValidated)
			{
			$application->enqueueMessage(' ');
		
				
			$application->enqueueMessage(JText::_('VMPAYMENT_PPP_SSC_REVIEW_YOUR_ORDER_DETAILS'));
		
			$application->enqueueMessage($new_message);
			}
		
 		}

 	$session->set('session_ssc_total', $cart->pricesUnformatted["billTotal"]);
	}


if($debug)
	{
	print '<br>';
	print 'New Price: ' . $new_price . '<br>';
	}



if($this->get_cookie('ssc_ecob') == '1')
	{
	
	$j = "<script language=\"javascript\">
	document.cookie = \"ssc_checkout=0;path=/\";
	document.cookie = \"ssc_ecob=0;path=/\";
	window.location=\"$url\";
	</script>
	<noscript>
	<meta http-equiv=\"refresh\" content=\"0;url=$url\">
	</noscript>
	";

	$doc =& JFactory::getDocument();
	$doc->addCustomTag($j);

	}
elseif($cart->_dataValidated && $this->get_cookie('ssc_checkout') == '1' && $new_price == 0)
	{
		$url = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=cart&task=updatecart&confirm=1&tos=1');

	$ver = VmConfig::getInstalledVersion();

	if($ver < '2.9')
		{
		$url = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=cart&task=confirm&tos=1');
		}	
	
$i = "
	<script language=\"javascript\">
		<!--
		document.cookie = \"ssc_checkout=0;path=/\";
		document.cookie = \"ssc_ecob=0;path=/\";
		window.location.href=\"$url\";
		//-->
	</script>
";


	$j = "
	<meta http-equiv=\"set-cookie\" content=\"ssc_checkout=0;path=/\">
	<meta http-equiv=\"set-cookie\" content=\"ssc_ecob=0;path=/\">
	<meta http-equiv=\"refresh\" content=\"0;url=$url\">
	";


	
	jimport('joomla.environment.browser');
	$doc =& JFactory::getDocument();
	$browser = &JBrowser::getInstance();
	$browserType = $browser->getBrowser();
		if($browserType == 'chrome')		{
		$i=$j;
		}

	$doc =& JFactory::getDocument();
	$doc->addCustomTag($i);
	
	


	
	}
	
	
	$checkout_button_1='';
	$checkout_button_2='';
	
$button_text = '';

$cookie_no = '0';

if(!$cart->_dataValidated)
	{
	$cookie_no='1';
	$button_text = 'Click to Continue';
	}
else
	{
	$cookie_no = '0';
	$button_text = 'Enter Payment Details';
	}
	
	
	$checkout_button =
	"<script language=\"javascript\">
	document.cookie = \"ssc_checkout=0;path=/\";

	if(window.addEventListener)
		{
		if(document.getElementById('checkoutFormSubmit') != null)
			{
			//document.getElementById('checkoutFormSubmit').innerHTML = '" . $button_text . "';
			document.getElementById('checkoutFormSubmit').addEventListener('click', function()
				{
				document.cookie = \"ssc_checkout=" . $cookie_no . ";path=/\";
				document.getElementById('checkoutFormSubmit').disabled = false;
				}, false);
			}
		window.addEventListener('load', function()
			{
			if(document.getElementById('checkoutFormSubmit') != null)
				{
				//document.getElementById('checkoutFormSubmit').innerHTML = '" . $button_text . "';
				document.getElementById('checkoutFormSubmit').addEventListener('click', function()
					{
					document.cookie = \"ssc_checkout=" . $cookie_no . ";path=/\";
					document.getElementById('checkoutFormSubmit').disabled = false;
					}, false);
				}	
			else 
				{				
				var position=-1;
				for (var i=0; i<document.anchors.length; i++)
					{
					try{
						if(document.anchors[i].href == \"javascript:document.checkoutForm.submit();\")
							{
							//alert(\"Found\" + i);
							position=i;
							i=document.anchors.length;	
							}
						}	
					catch(err){}//alert(\"error found\");
					}
				if(document.anchors[position] != null)
					{
					//document.anchors[position].innerHTML = '" . $button_text . "';
					document.anchors[position].addEventListener('click', function()
						{
						document.cookie = \"ssc_checkout=" . $cookie_no . ";path=/\";
						}, false);
					}		
				}
				
			}, false);
		}
	else if(window.attachEvent)
		{
		window.attachEvent('onload', function()
			{
			if(document.getElementById('checkoutFormSubmit') != null)
				{
				//document.getElementById('checkoutFormSubmit').innerHTML = '" . $button_text . "';
				document.getElementById('checkoutFormSubmit').attachEvent('onclick', function()
					{
					document.cookie = \"ssc_checkout=" . $cookie_no . ";path=/\";
					document.getElementById('checkoutFormSubmit').disabled = false;
					});
				}
			else
				{
				var position=-1;
				for (var i=0; i<document.anchors.length; i++)
					{
					try{
						if(document.anchors[i].href == \"javascript:document.checkoutForm.submit();\")
							{
							//alert(\"Found\" + i);
							position=i;
							i=document.anchors.length;	
							}
						}
					catch(err){}//alert(\"error found\");
					}
				
				if(document.anchors[position] != null)
					{
					//document.anchors[position].innerHTML = '" . $button_text . "';		
					document.anchors[position].attachEvent('onclick', function()
						{
						document.cookie = \"ssc_checkout=" . $cookie_no . ";path=/\";
						});
					}						
				}
			});
		}

	</script>";



$session_token = $session->get('session_token');
$session_PayerID = $session->get('session_PayerID');

$method->ssc_short_cut_cart = 0;

if($method->ssc_short_cut_cart == 1)
	{
	if($cart->virtuemart_paymentmethod_id > 0 && $cart->virtuemart_paymentmethod_id == $virtuemart_paymentmethod_id)
		{
		$html .= $checkout_button;
		}

	if(is_null($session->get('session_token')))
		{
						$html .= $ReturnURL;
				}	
	}




$user = JFactory::getUser();

if($user->id > 0)
	{
	$xff = $this->html_code();
	
	echo $xff; 
	}



	$payment_advertise[] = $html;	
	
}






function plgVmOnProductDisplayPayment($product, &$productDisplay)
	{

	$vendorId = 1;
	if ($this->getPluginMethods($vendorId) === 0)
		{
		return FALSE;
		}

$button_code =
'
<form name="pos_ssc">
<input type="hidden" name="place" value="1">
</form>

<script type="text/javascript">
function func1()
{

var position=0;

for (var i=0; i<document.forms.length; i++)
	{
	try{
		if(document.forms[i].name == "pos_ssc")
			{
			//alert("Found" + i);
			position=i;
			i=document.forms.length;	
			}
		}
	catch(err)
		{
		//alert("error found");
		}
	}


try{
	if(typeof document.forms[position+1].addtocart != "object" && position>0)
		{
		position=position-1;
		//alert("non standard layout");
		}
	else
		{
		//alert("standard layout");
		}	
	}
	catch(err)
		{
		//alert("error found");
		}



	
//alert(vmSiteurl + Virtuemart.addtocart_popup);
if(typeof Virtuemart !== "undefined")
	{
	Virtuemart.addtocart_popup=0;
	}
for (var i=position; i<document.forms.length; i++)
	{
	try{
		if(typeof document.forms[i].addtocart == "object")
			{
			//setCookie("ssc_ecob","1","path=/");
			document.cookie = "ssc_ecob=1;path=/";
			document.forms[i].addtocart.click();
			//alert("error");
			i=document.forms.length;	
			}
		}
	catch(err)
		{
		//alert("error found");
		}
	}
}


function setCookie(cname,cvalue,exdays)
{
var d = new Date();
//d.setTime(d.getTime()+(exdays*24*60*60*1000));
//var expires = "expires="+d.toGMTString();
var expires="";
document.cookie = cname + "=" + cvalue + "; " + expires;
}

function getCookie(cname)
{
var name = cname + "=";
var ca = document.cookie.split(";");
for(var i=0; i<ca.length; i++)
  {
  var c = ca[i].trim();
  if (c.indexOf(name)==0) return c.substring(name.length,c.length);
}
return "";
}
//document.cookie = "ssc_ecob=0;path=/";
</script>' .

'<br/><img style="border:0;margin-right:7px;cursor: pointer" src="https://fpdbs.paypal.com/dynamicimageweb?cmd=_dynamic-image" onclick="func1();" alt="PayPal" align="left"><br/><br/>';


$db = JFactory::getDbo();
$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalplusssc" AND `published` = 1';
$db->setQuery($q);
$virtuemart_paymentmethod_id = $db->loadResult();

if(!is_null($virtuemart_paymentmethod_id))
	{
	$method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);
	
		$method->ssc_short_cut_cart=0;
	if($method->ssc_short_cut_cart == '1')
		{
		$productDisplay[] = $button_code;
				}
	else
		{
				}
	
	}
else
	{
	echo 'Null';
	}

		
	$session = JFactory::getSession();

	if(is_null($session->get('session_token')))
		{
				}
	else
		{
			
		$session->set('session_token', null);
		$session->set('session_PayerID', null);
		}

		return TRUE;
	}


	function plgVmDisplayLogin2($user, &$html, $from_cart = FALSE)
		{
		$ver = VmConfig::getInstalledVersion();

		if (version_compare ($ver, '3.2.0', '>='))
			{
			return null;
			}
			
		$template = JFactory::getApplication()->getTemplate();	
		
		if($template == 'yootheme')
			{
			return null;	
			}
		
						if (!$from_cart)
			{
			return NULL;
			}
					
		$vendorId = 1;
		if (!class_exists('VirtueMartCart'))
			{
			require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php'); 			}

		$cart = VirtueMartCart::getCart();
		if ($this->getPluginMethods($cart->vendorId) === 0)
			{
			return FALSE;
			}
		
				if (isset($cart->pricesUnformatted['salesPrice']) && $cart->pricesUnformatted['salesPrice'] <= 0.0)
			{
			return FALSE;
			}
			
		if (!isset($cart->pricesUnformatted['salesPrice']))
			{
			return FALSE;
			}			
			
		
		if (!($this->_currentMethod = $this->getVmPluginMethod($cart->virtuemart_paymentmethod_id)))
			{
			return NULL;
			}

				
		$html = $this->html_code();

	}


function html_code()
{

$html='';

$css= "<style>
	//span.vmpayment_name + * + h3
	//{
	//width:100%;
	//opacity:0.0;
	//filter:alpha(opacity=0);
	//display:none
	//}

	//span.vmpayment_name + * + h3 + *
	//{
	//width:100%;
	//opacity:0.0;
	//filter:alpha(opacity=0);
	//display:none
	//}

	//input[name=virtuemart_paymentmethod_id]
	//{
	//width:100%;
	//opacity:0.0;
	//filter:alpha(opacity=0);
	//display:none
	//}

form#com-form-login
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
display:none
}

</style>
";

		

	
	

		
		
if($this->get_cookie('c') == '1')
	{
	$html .= '<br/><p><font face="Arial" size="5" color="#FF0000"><b style="background-color: #FFFFFF">' . JText::_('VMPAYMENT_PPP_SSC_YOUR_ORDER_IS_NOT_YET_COMPLETE') . '</b></font></p>';
	$html .= '<br/><p><font face="Arial" size="4" color="#008080"><b style="background-color: #FFFFFF">' . JText::_('VMPAYMENT_PPP_SSC_REVIEW_YOUR_ORDER_DETAILS') . '</b></font></p><br/>';
	
	$html .= "<script language=\"javascript\">";
	$html .= "document.cookie = \"c=0;path=/\";";
	$html .= "document.cookie = \"ceco=1;path=/\";";
	$html .= "</script>" . $css;
	}	
elseif($this->get_cookie('ceco') == '1' && $this->get_cookie('ssc_checkout') == '1')
	{
	$html .= '<br/><p><font face="Arial" size="5" color="#FF0000"><b style="background-color: #FFFFFF">' . JText::_('VMPAYMENT_PPP_SSC_YOUR_ORDER_IS_NOT_YET_COMPLETE') . '</b></font></p>';
	$html .= '<br/><p><font face="Arial" size="4" color="#008080"><b style="background-color: #FFFFFF">' . JText::_('VMPAYMENT_PPP_SSC_REVIEW_YOUR_ORDER_DETAILS') . '</b></font></p><br/>';
	
	$html .= "<script language=\"javascript\">";
	$html .= "document.cookie = \"c=0;path=/\";";
	$html .= "document.cookie = \"ceco=1;path=/\";";
	$html .= "</script>" . $css;
	}	
else
	{
	$html .= "<script language=\"javascript\">";
	$html .= "document.cookie = \"ceco=0;path=/\";";
	$html .= "</script>";
	}

return $html;


}






    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
	return $this->OnSelectCheck($cart);
    }

    /**
     * plgVmDisplayListFEPayment
     * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
     *
     * @param object $cart Cart object
     * @param integer $selected ID of the method selected
     * @return boolean True on succes, false on failures, null when this plugin was not selected.
     * On errors, J Error::raiseWarning (or J Error::raiseError) must be used to set a message.
     *
     * @author Valerie Isaksen
     * @author Max Milbers
     */
    public function plgVmDisplayListFEPayment2(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
	return $this->displayListFE($cart, $selected, $htmlIn);
    }


	function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {

				





		


		
		if ($this->getPluginMethods($cart->vendorId) === 0) {
			if (empty($this->_name)) {
				$app = JFactory::getApplication();
				$app->enqueueMessage(vmText::_('COM_VIRTUEMART_CART_NO_' . strtoupper($this->_psType)));
				return FALSE;
			} else {
				return FALSE;
			}
		}
		
		
		
		$html = array();
		$method_name = $this->_psType . '_name';
		

		JHTML::script('vmcreditcard.js', 'components/com_virtuemart/assets/js/', FALSE);
		VmConfig::loadJLang('com_virtuemart', true);
		vmJsApi::jCreditCard();
		$htmla = array();
		$html = array();
		

$opc = 0;
$vp_opc = 0;

		
	VmConfig::loadConfig();
	$vm_opc = vmConfig::get('oncheckout_opc',"0");
				
	
$db = JFactory::getDbo();
$db->setQuery("SELECT `enabled` FROM `#__extensions` WHERE `name` = 'plg_system_opc'");
$opc_enabled = $db->loadResult();
$opc = $opc_enabled;

if($opc_enabled != '1')
	{
	$db->setQuery("SELECT `enabled` FROM `#__extensions` WHERE `name` = 'VP One Page Checkout'");
	$opc_enabled = $db->loadResult();
	$vp_opc = $opc_enabled;
	}



	
		foreach ($this->methods as $this->_currentMethod)
			{
			
			
		


				
		$cartprices = null;
		
		if(isset($cart->cartPrices))
			{
			$cartprices = $cart->cartPrices;
			}
		else
			{
			$cartprices = $cart->pricesUnformatted;
			}
			
			
		if ($this->checkConditions($cart, $this->_currentMethod, $cartprices))
			{
			$methodSalesPrice = $this->setCartPrices($cart, $cartprices, $this->_currentMethod);
			
							
				$this->_currentMethod->$method_name = $this->renderPluginName($this->_currentMethod);
				$html = $this->getPluginHtml($this->_currentMethod, $selected, $methodSalesPrice);
				







$this->getPaymentCurrency($this->_currentMethod); $q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $this->_currentMethod->payment_currency . '" ';
$db = JFactory::getDBO();
$db->setQuery($q);
$currency_code_3 = $db->loadResult();


				

				$htmla[] = $html;
				
				
			}
		
		}
		
		$htmlIn[] = $htmla;


		return TRUE;

	}




























    

    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
	return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    /**
     * plgVmOnCheckAutomaticSelectedPayment
     * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
     * The plugin must check first if it is the correct type
     * @author Valerie Isaksen
     * @param VirtueMartCart cart: the cart object
     * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
     *
     */


  function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array(), &$paymentCounter) {
			  
			  
	$ver = VmConfig::getInstalledVersion();
	$arr = explode(' ',trim($ver));
	$ver = $arr[0];
	
	if (version_compare ($ver, '3.5.9', '>'))
		{
			   return $this->onCheckAutomaticSelected($cart, $cart_prices, $paymentCounter);
		}

				  
	
	$return = $this->onCheckAutomaticSelected($cart, $cart_prices);
		if (isset($return)) {
			return 0;
		} else {
			return NULL;
		}
	}



    /**
     * This method is fired when showing the order details in the frontend.
     * It displays the method-specific data.
     *
     * @param integer $order_id The order ID
     * @return mixed Null for methods that aren't active, text (HTML) otherwise
     * @author Max Milbers
     * @author Valerie Isaksen
     */
    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
	$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    /**
     * This event is fired during the checkout process. It can be used to validate the
     * method data as entered by the user.
     *
     * @return boolean True when the data was valid, false otherwise. If the plugin is not activated, it should return null.
     * @author Max Milbers

      public function plgVmOnCheckoutCheckDataPayment($psType, VirtueMartCart $cart) {
      return null;
      }
     */

    /**
     * This method is fired when showing when priting an Order
     * It displays the the payment method-specific data.
     *
     * @param integer $_virtuemart_order_id The order ID
     * @param integer $method_id  method used for this order
     * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
     * @author Valerie Isaksen
     */
    function plgVmonShowOrderPrintPayment($order_number, $method_id) {
	return $this->onShowOrderPrint($order_number, $method_id);
    }

    /**
     * Save updated order data to the method specific table
     *
     * @param array $_formData Form data
     * @return mixed, True on success, false on failures (the rest of the save-process will be
     * skipped!), or null when this method is not actived.
     * @author Oscar van Eijk

      public function plgVmOnUpdateOrderPayment(  $_formData) {
      return null;
      }
     */
    /**
     * Save updated orderline data to the method specific table
     *
     * @param array $_formData Form data
     * @return mixed, True on success, false on failures (the rest of the save-process will be
     * skipped!), or null when this method is not actived.
     * @author Oscar van Eijk

      public function plgVmOnUpdateOrderLine(  $_formData) {
      return null;
      }
     */
    /**
     * plgVmOnEditOrderLineBE
     * This method is fired when editing the order line details in the backend.
     * It can be used to add line specific package codes
     *
     * @param integer $_orderId The order ID
     * @param integer $_lineId
     * @return mixed Null for method that aren't active, text (HTML) otherwise
     * @author Oscar van Eijk

      public function plgVmOnEditOrderLineBE(  $_orderId, $_lineId) {
      return null;
      }
     */

    /**
     * This method is fired when showing the order details in the frontend, for every orderline.
     * It can be used to display line specific package codes, e.g. with a link to external tracking and
     * tracing systems
     *
     * @param integer $_orderId The order ID
     * @param integer $_lineId
     * @return mixed Null for method that aren't active, text (HTML) otherwise
     * @author Oscar van Eijk

      public function plgVmOnShowOrderLineFE(  $_orderId, $_lineId) {
      return null;
      }
     */
    function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
	return $this->declarePluginParams('payment', $name, $id, $data);
    }

	function plgVmDeclarePluginParamsPaymentVM3( &$data) {
		return $this->declarePluginParams('payment', $data);
	}

    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
	return $this->setOnTablePluginParams($name, $id, $table);
    }
    
 private function table_exist($table,$debug)
	{

	if (!class_exists('JConfig'))
		require(JPATH_CONFIGURATION . '/configuration.php');
	
	$cfg = new JConfig();
	$dbname = $cfg->db;
	$dbprefix = $cfg->dbprefix;		
		
	$table = $dbprefix . $table;

	if($debug)echo $table . '<br>Table name is ' . $table . '<br><br>';
		
	$tables = JFactory::getDbo()->getTableList();
	
		
	if(in_array($table,$tables))
		{
		if($debug)echo '<br>Table found<br><br>';
		return true;
		}
	else
		{
		if($debug)echo '<br>Table not found<br><br>';
		return false;
		}
	}  


public function post_strings()
	{
	$postvars = array();

	foreach ($_POST as $key => $value)
		{
		$value = preg_replace('/[^a-zA-Z0-9.-]/', '', $value);
		$postvars[$key] = $value;
		}

	return $postvars;
	}


public function get_strings()
	{
	$getvars= array();

	foreach ($_GET as $key => $value)
		{
		$value = preg_replace('/[^a-zA-Z0-9.-]/', '', $value);
		$getvars[$key] = $value;
		}

	return $getvars;
	}


	    
 function get_cookie($name)
	{
	$value = '';
    
	if(isset($_COOKIE[$name]))
		{
    	$value = $_COOKIE[$name];
    	$value = preg_replace('/[^a-zA-Z0-9.-]/', '', $value);
    	}
    	
	return $value;
	}


}
